# 视频播放器Demo（ArkTS）

### 简介

基于ArkUI开发的用于视频播放调测Demo。

### 相关参考

- [AVPlayer](https://developer.harmonyos.com/cn/docs/documentation/doc-references-V3/js-apis-media-0000001427902672-V3?ha_linker=eyJ0cyI6MTY4NDM5NDkyNzY4NCwiaWQiOiJhMDEwYWRjNDg3N2ZhMWYwMzc0ZTYzNTdlMjk3ZDkzZCJ9#ZH-CN_TOPIC_0000001493415664__avplayer9)：播放管理类：视频播放组件。
- [VideoPlayer](https://gitee.com/harmonyos/samples/tree/master/media/VideoPlayer)：官方视频播放器参考，视频编解码、视频合成、视频提取、视频播放以及视频录制等。
- [ohos_ijkplayer](https://gitee.com/openharmony-sig/ohos_ijkplayer)：ijkplayer是OpenHarmony环境下可用的一款基于FFmpeg的视频播放器。
- [组件参考](https://developer.harmonyos.com/cn/docs/documentation/doc-references-V4/84_u58f0_u660e_u5f0f_u5f00_u53d1_u8303_u5f0f_uff09-0000001630265689-V4?catalogVersion=V4)：基于ArkTS的声明式开发范式。
- [XComponent](https://developer.harmonyos.com/cn/docs/documentation/doc-references-V3/ts-basic-components-xcomponent-0000001427902468-V3?catalogVersion=V3&ha_linker=eyJ0cyI6MTY4NDM5NDk3NTE1MywiaWQiOiJhMDEwYWRjNDg3N2ZhMWYwMzc0ZTYzNTdlMjk3ZDkzZCJ9)：可用于EGL/OpenGLES和媒体数据写入，并显示在XComponent组件。
- [issue提单地址](https://issuereporter.developer.huawei.com/my-created)：任何系统能力相关的咨询、问题和述求都可以在这里提单跟踪。

## 如何编译
1. 若amdemos-player-ohos-listapp路径不存在，进入AliPlayerDemo，执行脚本:
```
./pull_listapp.sh
```
2. 完成后项目中增加路径：amdemos-player-ohos-listapp，进入查看oh-package.json5
3. 确认oh-package.json5的依赖为以下：
```
  "dependencies": {
    "premierlibrary":  "file:../amdemos-player-ohos-listapp/libs/premierlibrary.har"
  }
```
## 目录结构
目录结构比较简单，没有做目录规划，代码正在重构，计划27号下班前重构完。
```
|---- AliPlayerDemo  
|     |---- amdemos-player-ohos-listapp  # demo目录
|            |---- libs  # 用于存放依赖文件
|            |---- src
|                  |----- main  #代码逻辑及资源目录
|                          |----- ets       #业务代码
|                                  |----- common        # 公共常量及工具类
|                                  |----- controller    # 业务控制类
|                                  |----- entryability  # demo主入口
|                                  |----- pages         # 用于存放页面
|                                  |----- view          # 自定义样式的组件
|                          |----- resources #资源目录           
```

### 相关权限
需要在module.json5中配置如下权限用于请求网络：

```
"requestPermissions": [
  {
    "name": "ohos.permission.INTERNET"
  }
]
```
### 添加依赖
需要在工程目录下的oh-package.json5中添加如下依赖
```
  "dependencies": {
    "premierlibrary":  "file:../amdemos-player-ohos-listapp/libs/premierlibrary.har"
  }
```

### 使用说明

1. 获取网络视频。
2. 通过IPlayer相关接口进行视频播放。
3. 通过界面上相关按钮、输入框、滑动条进行播放测试。

### 约束与限制

1. 仅支持标准系统上运行，支持设备：华为手机鸿蒙版本。
2. 本示例为Stage模型，基于API version 10、11.
3. 本示例需要使用DevEco Studio 4.0 Release（Build Version: 4.0.3.700）版本进行编译运行。目前4.1.3.500也可编译运行。