import promptAction from "@ohos:promptAction";
import { AliPlayerGlobalSettings } from "@package:pkg_modules/.ohpm/premierlibrary@donfdoen1mcr6ssy+rjg6ltkuce=/pkg_modules/premierlibrary/Index";
import { LOCAL_PROP_KEY_HARDWARE_DECODE_ENABLED, LOCAL_PROP_KEY_HTTP2_ENABLED } from "@bundle:com.aliyun.player.ohos_demo/listapp/ets/common/Constants";
/**
 * 转换时间所用常量.
 */
const TIME_UNIT: number = 60;
/**
 * 时间片段.
 */
const INITIAL_TIME_UNIT: string = '00';
/**
 * 每个片段所占字符个数.
 */
const PADDING_LENGTH: number = 2;
/**
 * 占位符.
 */
const PADDING_STR: string = '0';
export class CommonUtils {
    /**
     * 时间格式：Hour-minute-second
     *
     * @param seconds 入参已秒为单位
     * @returns 返回一个格式化后的字符串
     */
    static secondToTime(seconds: number): string {
        let hourUnit = TIME_UNIT * TIME_UNIT;
        let hour = Math.floor(seconds / hourUnit);
        let minute = Math.floor((seconds - hour * hourUnit) / TIME_UNIT);
        let second = seconds - hour * hourUnit - minute * TIME_UNIT;
        if (hour > 0) {
            return `${CommonUtils.padding(hour.toString())}${':'}
        ${CommonUtils.padding(minute.toString())}${':'}${CommonUtils.padding(second.toString())}`;
        }
        if (minute > 0) {
            return `${CommonUtils.padding(minute.toString())}${':'}${CommonUtils.padding(second.toString())}`;
        }
        else {
            return `${INITIAL_TIME_UNIT}${':'}${CommonUtils.padding(second.toString())}`;
        }
        return '';
    }
    /**
     * 增加占位符.
     */
    static padding(num: string): string {
        let length = PADDING_LENGTH;
        for (let len = (num.toString()).length; len < length; len = num.length) {
            num = `${PADDING_STR}${num}`;
        }
        return num;
    }
}
export function showToast(message: string) {
    try {
        promptAction.showToast({
            message: message,
            duration: 1500,
        });
    }
    catch (error) {
        console.error(`showToast args error code is ${error.code}, message is ${error.message}`);
    }
    ;
}
export function initGlobalSettings() {
    // 设置app全局存储
    checkSetting(LOCAL_PROP_KEY_HARDWARE_DECODE_ENABLED, true); // 硬解码
    checkSetting(LOCAL_PROP_KEY_HTTP2_ENABLED, true);
    // 全局设置 初始化时set给SDK
    setGlobalSettingApi();
}
function checkSetting(settingName: string, value: boolean | number | string) {
    const setting: boolean | number | string | undefined = AppStorage.get(settingName);
    if (setting === undefined) {
        // showToast(setting + '');
        AppStorage.setOrCreate(settingName, value);
    }
}
function setGlobalSettingApi() {
    let flag: boolean = false;
    // http2
    flag = !!AppStorage.get(LOCAL_PROP_KEY_HTTP2_ENABLED);
    AliPlayerGlobalSettings.setUseHttp2(flag);
    console.log("HOS DEMO", "Http2 ", flag);
    // ...
}
