import type AbilityConstant from "@ohos:app.ability.AbilityConstant";
import UIAbility from "@ohos:app.ability.UIAbility";
import type Want from "@ohos:app.ability.Want";
import type window from "@ohos:window";
import { Hlog } from "@bundle:com.aliyun.player.ohos_demo/listapp/ets/common/util/Hlog";
const log: Hlog = new Hlog('EntryAbility');
export default class EntryAbility extends UIAbility {
    onCreate(want: Want, launchParam: AbilityConstant.LaunchParam): void {
        log.i('Ability onCreate');
    }
    onDestroy(): void {
        log.i('Ability onDestroy');
    }
    onWindowStageCreate(windowStage: window.WindowStage): void {
        // Main window is created, set main page for this ability
        log.i('Ability onWindowStageCreate');
        windowStage.loadContent('pages/HomePage', (err, data) => {
            if (err.code) {
                log.e(`Failed to load the content. Cause: ${JSON.stringify(err)}`);
                return;
            }
            log.i(`Succeeded in loading the content. Data: ${JSON.stringify(data)}`);
        });
    }
    onWindowStageDestroy(): void {
        // Main window is destroyed, release UI related resources
        log.i('Ability onWindowStageDestroy');
    }
    onForeground(): void {
        // Ability has brought to foreground
        log.i('Ability onForeground');
    }
    onBackground(): void {
        // Ability has back to background
        log.i('Ability onBackground');
    }
    onPrepareToTerminate(): boolean {
        log.i('Ability onPrepareToTerminate');
        return true;
    }
    onBackPressed(): boolean {
        log.i('Ability onBackPressed');
        return true;
    }
}
