interface UrlDialogComponent_Params {
    mController?: CustomDialogController;
}
interface NormalButton_Params {
    title?: string;
    playerIndex?: number;
    buttonType?: number;
}
interface PlayerPage_Params {
    mDialogController?: CustomDialogController;
    mUrlListListener?: onRightClickListener;
    videoUrlList?: Array<string>;
    playerInstancesIndex?: Array<number>;
    gridMargin?: number;
    gridGutter?: number;
    sm?: number;
    isFullScreen?: boolean;
    showFinishScene?: boolean;
    showLoadingScene?: boolean;
    seekType?: SEEK_TYPE;
}
import { HeaderComponent } from "@bundle:com.aliyun.player.ohos_demo/listapp/ets/view/HeaderComponent";
import type { onRightClickListener } from "@bundle:com.aliyun.player.ohos_demo/listapp/ets/view/HeaderComponent";
import { VideoComponent } from "@bundle:com.aliyun.player.ohos_demo/listapp/ets/view/VideoComponent";
import VideoController from "@bundle:com.aliyun.player.ohos_demo/listapp/ets/controller/VideoController";
import { Hlog } from "@bundle:com.aliyun.player.ohos_demo/listapp/ets/common/util/Hlog";
import router from "@ohos:router";
import { SEEK_TYPE } from "@bundle:com.aliyun.player.ohos_demo/listapp/ets/common/Constants";
import { showToast } from "@bundle:com.aliyun.player.ohos_demo/listapp/ets/common/util/CommonUtils";
const log: Hlog = new Hlog('PlayerPage');
const TYPE_READY: number = 0x1;
const TYPE_PLAYER: number = 0x2;
const TYPE_STOP: number = 0x4;
const TYPE_PAUSE: number = 0x8;
const TYPE_CAPTURE: number = 0x16;
class PlayerPage extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1, paramsLambda = undefined, extraInfo) {
        super(parent, __localStorage, elmtId, extraInfo);
        if (typeof paramsLambda === "function") {
            this.paramsGenerator_ = paramsLambda;
        }
        this.mDialogController = new CustomDialogController({
            builder: () => {
                let paramsLambda = () => {
                    return {};
                };
                let jsDialog = new UrlDialogComponent(this, {}, undefined, -1, paramsLambda, { page: "amdemos-player-ohos-listapp/src/main/ets/pages/ListPlayerPage.ets", line: 26 });
                jsDialog.setController(this.mDialogController);
                ViewPU.create(jsDialog);
            },
            alignment: DialogAlignment.Center,
            gridCount: 3,
            autoCancel: true,
            cornerRadius: 2
        }, this);
        this.mUrlListListener = {
            onRightItemClick: () => {
                this.mDialogController.open();
            }
        };
        this.__videoUrlList = new ObservedPropertyObjectPU([], this, "videoUrlList");
        this.__playerInstancesIndex = new ObservedPropertyObjectPU([], this, "playerInstancesIndex");
        this.__gridMargin = new ObservedPropertySimplePU(10, this, "gridMargin");
        this.__gridGutter = new ObservedPropertySimplePU(10, this, "gridGutter");
        this.__sm = new ObservedPropertySimplePU(-2, this, "sm");
        this.__isFullScreen = new ObservedPropertySimplePU(false, this, "isFullScreen");
        this.__showFinishScene = new ObservedPropertySimplePU(false, this, "showFinishScene");
        this.__showLoadingScene = new ObservedPropertySimplePU(false, this, "showLoadingScene");
        this.__seekType = new ObservedPropertySimplePU(SEEK_TYPE.NORMAL, this, "seekType");
        this.setInitiallyProvidedValue(params);
    }
    setInitiallyProvidedValue(params: PlayerPage_Params) {
        if (params.mDialogController !== undefined) {
            this.mDialogController = params.mDialogController;
        }
        if (params.mUrlListListener !== undefined) {
            this.mUrlListListener = params.mUrlListListener;
        }
        if (params.videoUrlList !== undefined) {
            this.videoUrlList = params.videoUrlList;
        }
        if (params.playerInstancesIndex !== undefined) {
            this.playerInstancesIndex = params.playerInstancesIndex;
        }
        if (params.gridMargin !== undefined) {
            this.gridMargin = params.gridMargin;
        }
        if (params.gridGutter !== undefined) {
            this.gridGutter = params.gridGutter;
        }
        if (params.sm !== undefined) {
            this.sm = params.sm;
        }
        if (params.isFullScreen !== undefined) {
            this.isFullScreen = params.isFullScreen;
        }
        if (params.showFinishScene !== undefined) {
            this.showFinishScene = params.showFinishScene;
        }
        if (params.showLoadingScene !== undefined) {
            this.showLoadingScene = params.showLoadingScene;
        }
        if (params.seekType !== undefined) {
            this.seekType = params.seekType;
        }
    }
    updateStateVars(params: PlayerPage_Params) {
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
        this.__videoUrlList.purgeDependencyOnElmtId(rmElmtId);
        this.__playerInstancesIndex.purgeDependencyOnElmtId(rmElmtId);
        this.__gridMargin.purgeDependencyOnElmtId(rmElmtId);
        this.__gridGutter.purgeDependencyOnElmtId(rmElmtId);
        this.__sm.purgeDependencyOnElmtId(rmElmtId);
        this.__isFullScreen.purgeDependencyOnElmtId(rmElmtId);
        this.__showFinishScene.purgeDependencyOnElmtId(rmElmtId);
        this.__showLoadingScene.purgeDependencyOnElmtId(rmElmtId);
        this.__seekType.purgeDependencyOnElmtId(rmElmtId);
    }
    aboutToBeDeleted() {
        this.__videoUrlList.aboutToBeDeleted();
        this.__playerInstancesIndex.aboutToBeDeleted();
        this.__gridMargin.aboutToBeDeleted();
        this.__gridGutter.aboutToBeDeleted();
        this.__sm.aboutToBeDeleted();
        this.__isFullScreen.aboutToBeDeleted();
        this.__showFinishScene.aboutToBeDeleted();
        this.__showLoadingScene.aboutToBeDeleted();
        this.__seekType.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    private mDialogController: CustomDialogController;
    private mUrlListListener: onRightClickListener;
    private __videoUrlList: ObservedPropertyObjectPU<Array<string>>;
    get videoUrlList() {
        return this.__videoUrlList.get();
    }
    set videoUrlList(newValue: Array<string>) {
        this.__videoUrlList.set(newValue);
    }
    private __playerInstancesIndex: ObservedPropertyObjectPU<Array<number>>;
    get playerInstancesIndex() {
        return this.__playerInstancesIndex.get();
    }
    set playerInstancesIndex(newValue: Array<number>) {
        this.__playerInstancesIndex.set(newValue);
    }
    private __gridMargin: ObservedPropertySimplePU<number>;
    get gridMargin() {
        return this.__gridMargin.get();
    }
    set gridMargin(newValue: number) {
        this.__gridMargin.set(newValue);
    }
    private __gridGutter: ObservedPropertySimplePU<number>;
    get gridGutter() {
        return this.__gridGutter.get();
    }
    set gridGutter(newValue: number) {
        this.__gridGutter.set(newValue);
    }
    private __sm: ObservedPropertySimplePU<number>;
    get sm() {
        return this.__sm.get();
    }
    set sm(newValue: number) {
        this.__sm.set(newValue);
    }
    private __isFullScreen: ObservedPropertySimplePU<boolean>;
    get isFullScreen() {
        return this.__isFullScreen.get();
    }
    set isFullScreen(newValue: boolean) {
        this.__isFullScreen.set(newValue);
    }
    private __showFinishScene: ObservedPropertySimplePU<boolean>;
    get showFinishScene() {
        return this.__showFinishScene.get();
    }
    set showFinishScene(newValue: boolean) {
        this.__showFinishScene.set(newValue);
    }
    private __showLoadingScene: ObservedPropertySimplePU<boolean>;
    get showLoadingScene() {
        return this.__showLoadingScene.get();
    }
    set showLoadingScene(newValue: boolean) {
        this.__showLoadingScene.set(newValue);
    }
    private __seekType: ObservedPropertySimplePU<SEEK_TYPE>;
    get seekType() {
        return this.__seekType.get();
    }
    set seekType(newValue: SEEK_TYPE) {
        this.__seekType.set(newValue);
    }
    aboutToAppear() {
        let params: object = router.getParams();
        this.videoUrlList = params['videoUrlList'];
        showToast(this.videoUrlList.length.toString());
        this.playerInstancesIndex = new Array(this.videoUrlList.length);
        for (let i = 0; i < this.videoUrlList.length; i++) {
            this.playerInstancesIndex[i] = VideoController.createAliPlayer(getContext(), null);
        }
    }
    aboutToDisappear() {
        for (let i = 0; i < this.playerInstancesIndex.length; i++) {
            VideoController.getPlayer(this.playerInstancesIndex[i])?.stop();
            // TODO: fix crash when release()
            // VideoController.dispose(this.playerInstancesIndex[i]);
            this.playerInstancesIndex[i] = -1;
        }
    }
    initialRender() {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Row.create();
            Row.height('100%');
            Row.alignItems(VerticalAlign.Top);
        }, Row);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Column.create();
            Column.width('100%');
        }, Column);
        {
            this.observeComponentCreation2((elmtId, isInitialRender) => {
                if (isInitialRender) {
                    let paramsLambda = () => {
                        return {
                            title: '多实例播放',
                            rightTitle: 'URL列表',
                            rightListener: this.mUrlListListener
                        };
                    };
                    ViewPU.create(new HeaderComponent(this, { title: '多实例播放', rightTitle: 'URL列表', rightListener: this.mUrlListListener }, undefined, elmtId, paramsLambda, { page: "amdemos-player-ohos-listapp/src/main/ets/pages/ListPlayerPage.ets", line: 68 }));
                }
                else {
                    this.updateStateVarsOfChildByElmtId(elmtId, {});
                }
            }, { name: "HeaderComponent" });
        }
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            List.create({ space: 8, initialIndex: 0 });
            List.listDirection(Axis.Vertical);
            List.scrollBar(BarState.Off);
            List.friction(0.6);
            List.edgeEffect(EdgeEffect.Spring);
            List.width('98%');
            List.margin({ bottom: 60 });
        }, List);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            ForEach.create();
            const forEachItemGenFunction = (_item, index: number) => {
                const item = _item;
                {
                    const itemCreation = (elmtId, isInitialRender) => {
                        ViewStackProcessor.StartGetAccessRecordingFor(elmtId);
                        itemCreation2(elmtId, isInitialRender);
                        if (!isInitialRender) {
                            ListItem.pop();
                        }
                        ViewStackProcessor.StopGetAccessRecording();
                    };
                    const itemCreation2 = (elmtId, isInitialRender) => {
                        ListItem.create(deepRenderFunction, true);
                    };
                    const deepRenderFunction = (elmtId, isInitialRender) => {
                        itemCreation(elmtId, isInitialRender);
                        this.SimplePlayerItem.bind(this)(item, this.playerInstancesIndex[index]);
                        ListItem.pop();
                    };
                    this.observeComponentCreation2(itemCreation2, ListItem);
                    ListItem.pop();
                }
            };
            this.forEachUpdateFunction(elmtId, this.videoUrlList, forEachItemGenFunction, undefined, true, false);
        }, ForEach);
        ForEach.pop();
        List.pop();
        Column.pop();
        Row.pop();
    }
    SimplePlayerItem(videoUrl: string, playerIndex: number, parent = null) {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Column.create();
            Column.width('100%');
            Column.height(240);
            Column.justifyContent(FlexAlign.Start);
        }, Column);
        {
            this.observeComponentCreation2((elmtId, isInitialRender) => {
                if (isInitialRender) {
                    let paramsLambda = () => {
                        return {
                            videoUrl: videoUrl,
                            playerIndex: playerIndex,
                            seekType: this.seekType,
                            isFullScreen: this.isFullScreen,
                            showFinishScene: this.showFinishScene,
                            showLoadingScene: this.showLoadingScene
                        };
                    };
                    ViewPU.create(new VideoComponent(this, {
                        videoUrl: videoUrl,
                        playerIndex: playerIndex,
                        seekType: this.__seekType,
                        isFullScreen: this.__isFullScreen,
                        showFinishScene: this.__showFinishScene,
                        showLoadingScene: this.__showLoadingScene
                    }, undefined, elmtId, paramsLambda, { page: "amdemos-player-ohos-listapp/src/main/ets/pages/ListPlayerPage.ets", line: 91 }));
                }
                else {
                    this.updateStateVarsOfChildByElmtId(elmtId, {
                        playerIndex: playerIndex
                    });
                }
            }, { name: "VideoComponent" });
        }
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Row.create();
            Row.justifyContent(FlexAlign.Center);
        }, Row);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            __Common__.create();
            __Common__.width('25%');
        }, __Common__);
        {
            this.observeComponentCreation2((elmtId, isInitialRender) => {
                if (isInitialRender) {
                    let paramsLambda = () => {
                        return {
                            title: '准备',
                            buttonType: TYPE_READY,
                            playerIndex: playerIndex
                        };
                    };
                    ViewPU.create(new NormalButton(this, { title: '准备', buttonType: TYPE_READY, playerIndex: playerIndex }, undefined, elmtId, paramsLambda, { page: "amdemos-player-ohos-listapp/src/main/ets/pages/ListPlayerPage.ets", line: 100 }));
                }
                else {
                    this.updateStateVarsOfChildByElmtId(elmtId, {
                        playerIndex: playerIndex
                    });
                }
            }, { name: "NormalButton" });
        }
        __Common__.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            __Common__.create();
            __Common__.width('25%');
        }, __Common__);
        {
            this.observeComponentCreation2((elmtId, isInitialRender) => {
                if (isInitialRender) {
                    let paramsLambda = () => {
                        return {
                            title: '播放',
                            buttonType: TYPE_PLAYER,
                            playerIndex: playerIndex
                        };
                    };
                    ViewPU.create(new NormalButton(this, { title: '播放', buttonType: TYPE_PLAYER, playerIndex: playerIndex }, undefined, elmtId, paramsLambda, { page: "amdemos-player-ohos-listapp/src/main/ets/pages/ListPlayerPage.ets", line: 101 }));
                }
                else {
                    this.updateStateVarsOfChildByElmtId(elmtId, {
                        playerIndex: playerIndex
                    });
                }
            }, { name: "NormalButton" });
        }
        __Common__.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            __Common__.create();
            __Common__.width('25%');
        }, __Common__);
        {
            this.observeComponentCreation2((elmtId, isInitialRender) => {
                if (isInitialRender) {
                    let paramsLambda = () => {
                        return {
                            title: '暂停',
                            buttonType: TYPE_PAUSE,
                            playerIndex: playerIndex
                        };
                    };
                    ViewPU.create(new NormalButton(this, { title: '暂停', buttonType: TYPE_PAUSE, playerIndex: playerIndex }, undefined, elmtId, paramsLambda, { page: "amdemos-player-ohos-listapp/src/main/ets/pages/ListPlayerPage.ets", line: 102 }));
                }
                else {
                    this.updateStateVarsOfChildByElmtId(elmtId, {
                        playerIndex: playerIndex
                    });
                }
            }, { name: "NormalButton" });
        }
        __Common__.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            __Common__.create();
            __Common__.width('25%');
        }, __Common__);
        {
            this.observeComponentCreation2((elmtId, isInitialRender) => {
                if (isInitialRender) {
                    let paramsLambda = () => {
                        return {
                            title: '停止',
                            buttonType: TYPE_STOP,
                            playerIndex: playerIndex
                        };
                    };
                    ViewPU.create(new NormalButton(this, { title: '停止', buttonType: TYPE_STOP, playerIndex: playerIndex }, undefined, elmtId, paramsLambda, { page: "amdemos-player-ohos-listapp/src/main/ets/pages/ListPlayerPage.ets", line: 103 }));
                }
                else {
                    this.updateStateVarsOfChildByElmtId(elmtId, {
                        playerIndex: playerIndex
                    });
                }
            }, { name: "NormalButton" });
        }
        __Common__.pop();
        Row.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Divider.create();
            Divider.strokeWidth(1);
            Divider.color('#444444');
            Divider.margin({ bottom: 8 });
        }, Divider);
        Column.pop();
    }
    rerender() {
        this.updateDirtyElements();
    }
    static getEntryName(): string {
        return "PlayerPage";
    }
}
class NormalButton extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1, paramsLambda = undefined, extraInfo) {
        super(parent, __localStorage, elmtId, extraInfo);
        if (typeof paramsLambda === "function") {
            this.paramsGenerator_ = paramsLambda;
        }
        this.__title = new ObservedPropertySimplePU('', this, "title");
        this.__playerIndex = new SynchedPropertySimpleOneWayPU(params.playerIndex, this, "playerIndex");
        this.buttonType = 0;
        this.setInitiallyProvidedValue(params);
    }
    setInitiallyProvidedValue(params: NormalButton_Params) {
        if (params.title !== undefined) {
            this.title = params.title;
        }
        if (params.playerIndex === undefined) {
            this.__playerIndex.set(-1);
        }
        if (params.buttonType !== undefined) {
            this.buttonType = params.buttonType;
        }
    }
    updateStateVars(params: NormalButton_Params) {
        this.__playerIndex.reset(params.playerIndex);
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
        this.__title.purgeDependencyOnElmtId(rmElmtId);
        this.__playerIndex.purgeDependencyOnElmtId(rmElmtId);
    }
    aboutToBeDeleted() {
        this.__title.aboutToBeDeleted();
        this.__playerIndex.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    private __title: ObservedPropertySimplePU<string>;
    get title() {
        return this.__title.get();
    }
    set title(newValue: string) {
        this.__title.set(newValue);
    }
    private __playerIndex: SynchedPropertySimpleOneWayPU<number>;
    get playerIndex() {
        return this.__playerIndex.get();
    }
    set playerIndex(newValue: number) {
        this.__playerIndex.set(newValue);
    }
    private buttonType: number;
    initialRender() {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Button.createWithLabel(this.title, { type: ButtonType.Normal, stateEffect: true });
            Button.backgroundColor(0xFFFFFF);
            Button.fontColor(0x0000CC);
            Button.width('100%');
            Button.onClick(() => {
                log.i(this.title + ',buttonType: ' + this.buttonType);
                switch (this.buttonType) {
                    case TYPE_READY:
                        VideoController.getPlayer(this.playerIndex)?.prepare();
                        showToast("PREPARE");
                        break;
                    case TYPE_PLAYER:
                        VideoController.getPlayer(this.playerIndex)?.start();
                        showToast("START");
                        break;
                    case TYPE_STOP:
                        VideoController.getPlayer(this.playerIndex)?.stop();
                        // showToast("STOP");
                        break;
                    case TYPE_PAUSE:
                        VideoController.getPlayer(this.playerIndex)?.pause();
                        showToast("PAUSE");
                        break;
                    case TYPE_CAPTURE:
                        break;
                }
            });
        }, Button);
        Button.pop();
    }
    rerender() {
        this.updateDirtyElements();
    }
}
class UrlDialogComponent extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1, paramsLambda = undefined, extraInfo) {
        super(parent, __localStorage, elmtId, extraInfo);
        if (typeof paramsLambda === "function") {
            this.paramsGenerator_ = paramsLambda;
        }
        this.mController = undefined;
        this.setInitiallyProvidedValue(params);
    }
    setInitiallyProvidedValue(params: UrlDialogComponent_Params) {
        if (params.mController !== undefined) {
            this.mController = params.mController;
        }
    }
    updateStateVars(params: UrlDialogComponent_Params) {
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
    }
    aboutToBeDeleted() {
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    private mController?: CustomDialogController;
    setController(ctr: CustomDialogController) {
        this.mController = ctr;
    }
    private onDialogClick(index: number) {
        log.i('onDialogClick: ' + index);
        switch (index) {
            case 0: // 对话框点击清空列表
                break;
            case 1: // 添加列表
                break;
            default:
                break;
        }
    }
    initialRender() {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Column.create();
            Column.width('100%');
        }, Column);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Blank.create();
            Blank.width('100%');
            Blank.height(250);
        }, Blank);
        Blank.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Row.create();
            Row.width('100%');
        }, Row);
        this.DialogButton.bind(this)('清空列表', 0);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Blank.create();
        }, Blank);
        Blank.pop();
        this.DialogButton.bind(this)('添加列表', 1);
        Row.pop();
        Column.pop();
    }
    DialogButton(title: string, index: number, parent = null) {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Button.createWithLabel(title, { type: ButtonType.Normal, stateEffect: true });
            Button.fontColor(0x333333);
            Button.fontSize(12);
            Button.backgroundColor(0xCCCCCC);
            Button.borderRadius(2);
            Button.margin({ left: 10, right: 10, bottom: 10 });
            Button.onClick(() => {
                this.onDialogClick(index);
            });
        }, Button);
        Button.pop();
    }
    rerender() {
        this.updateDirtyElements();
    }
}
interface OnToggleListener {
    onToggleChange: (isOn: boolean) => void;
}
registerNamedRoute(() => new PlayerPage(undefined, {}), "", { bundleName: "com.aliyun.player.ohos_demo", moduleName: "listapp", pagePath: "pages/ListPlayerPage" });
