interface UrlDialogComponent_Params {
    mController?: CustomDialogController;
}
interface PlayerConfigTabComponent_Params {
    playerIndex?: number;
    scroller?: Scroller;
    mPlayerConfig?: PlayerConfig;
    mVideoTunnelRenderListener?: OnToggleListener;
}
interface OptionsTabComponent_Params {
    volume?: number;
    mBackgroundColor?: string;
    mBitBandWidth?: string;
    playerIndex?: number;
    hardwareDecodedEnableLocked?: boolean;
    switchedToSoft?: boolean;
    seekType?: SEEK_TYPE;
    enableBackStagePlayback?: boolean;
    mOnBackStagePlaybackToggled?: OnToggleListener;
    scroller?: Scroller;
    mMultiplyPlayback?: OnSelectListener;
    mScaleModePlayBack?: OnSelectListener;
    mMirrorModePlayBack?: OnSelectListener;
    mRotateModePlayBack?: OnSelectListener;
    mAutoplayToggleListener?: OnToggleListener;
    mMuteToggleListener?: OnToggleListener;
    mLoopToggleListener?: OnToggleListener;
    mHardwareDecodeToggleListener?: OnToggleListener;
    mAccurateSeekToggleListener?: OnToggleListener;
}
interface NormalButton_Params {
    title?: string;
    playerIndex?: number;
    mOnButtonClicked?: OnButtonCLicked;
    buttonType?: number;
}
interface ToggleCommponent_Params {
    mListener?: OnToggleListener;
    title?: string;
    lockState?: boolean | undefined;
}
interface PlayerPage_Params {
    mDialogController?: CustomDialogController;
    mUrlListListener?: onRightClickListener;
    mOnFullscreenToggled?: OnFullscreenToggleListener;
    mOnSwitchedToSoft?: OnSwitchedToSoftListener;
    isFullScreen?: boolean;
    showFinishScene?: boolean;
    showLoadingScene?: boolean;
    videoUrl?: string;
    controller?: TabsController;
    gridMargin?: number;
    gridGutter?: number;
    sm?: number;
    tabSelectIndex?: number;
    seekType?: SEEK_TYPE;
    switchedToSoft?: boolean;
    enableBackStagePlayback?: boolean;
    userPaused?: boolean;
    backStaged?: boolean;
    aliPlayerIndex?: number;
    playerConfig?: PlayerConfig;
    context?: Context;
    listener?;
    mOnOperationClicked?: OnButtonCLicked;
    mOnBackStagePlaybackToggled?: OnToggleListener;
}
import { HeaderComponent } from "@bundle:com.aliyun.player.ohos_demo/listapp/ets/view/HeaderComponent";
import type { onRightClickListener } from "@bundle:com.aliyun.player.ohos_demo/listapp/ets/view/HeaderComponent";
import { VideoComponent } from "@bundle:com.aliyun.player.ohos_demo/listapp/ets/view/VideoComponent";
import VideoController from "@bundle:com.aliyun.player.ohos_demo/listapp/ets/controller/VideoController";
import { Hlog } from "@bundle:com.aliyun.player.ohos_demo/listapp/ets/common/util/Hlog";
import router from "@ohos:router";
import { LOCAL_PROP_KEY_HARDWARE_DECODE_ENABLED, LOCAL_PROP_KEY_VOLUME, SEEK_TYPE } from "@bundle:com.aliyun.player.ohos_demo/listapp/ets/common/Constants";
import { SelectComponent } from "@bundle:com.aliyun.player.ohos_demo/listapp/ets/view/SelectComponent";
import type { OnSelectListener } from "@bundle:com.aliyun.player.ohos_demo/listapp/ets/view/SelectComponent";
import { showToast } from "@bundle:com.aliyun.player.ohos_demo/listapp/ets/common/util/CommonUtils";
import { MirrorMode, RotateMode, ScaleMode } from "@package:pkg_modules/.ohpm/premierlibrary@donfdoen1mcr6ssy+rjg6ltkuce=/pkg_modules/premierlibrary/src/main/ets/com/aliyun/player/IPlayer";
import window from "@ohos:window";
import { PlayerConfig } from "@package:pkg_modules/.ohpm/premierlibrary@donfdoen1mcr6ssy+rjg6ltkuce=/pkg_modules/premierlibrary/src/main/ets/com/aliyun/player/nativeclass/PlayerConfig";
import mediaquery from "@ohos:mediaquery";
import backgroundTaskManager from "@ohos:resourceschedule.backgroundTaskManager";
import type { BusinessError } from "@ohos:base";
import wantAgent from "@ohos:app.ability.wantAgent";
import type { WantAgent } from "@ohos:app.ability.wantAgent";
const log: Hlog = new Hlog('PlayerPage');
const TYPE_READY: number = 0x1;
const TYPE_PLAYER: number = 0x2;
const TYPE_STOP: number = 0x4;
const TYPE_PAUSE: number = 0x8;
const TYPE_CAPTURE: number = 0x16;
class PlayerPage extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1, paramsLambda = undefined, extraInfo) {
        super(parent, __localStorage, elmtId, extraInfo);
        if (typeof paramsLambda === "function") {
            this.paramsGenerator_ = paramsLambda;
        }
        this.mDialogController = new CustomDialogController({
            builder: () => {
                let paramsLambda = () => {
                    return {};
                };
                let jsDialog = new UrlDialogComponent(this, {}, undefined, -1, paramsLambda, { page: "amdemos-player-ohos-listapp/src/main/ets/pages/PlayerPage.ets", line: 42 });
                jsDialog.setController(this.mDialogController);
                ViewPU.create(jsDialog);
            },
            alignment: DialogAlignment.Center,
            gridCount: 3,
            autoCancel: true,
            cornerRadius: 2
        }, this);
        this.mUrlListListener = {
            onRightItemClick: () => {
                this.mDialogController.open();
            }
        };
        this.mOnFullscreenToggled = {
            onFullscreenToggled: () => {
                this.onFullScreenChanged();
            }
        };
        this.mOnSwitchedToSoft = {
            onSwitched: () => {
                console.log("HOS DEMO", "SOFT DECODE IS TRUE");
                this.switchedToSoft = true;
            }
        };
        this.__isFullScreen = new ObservedPropertySimplePU(false, this, "isFullScreen");
        this.__showFinishScene = new ObservedPropertySimplePU(false, this, "showFinishScene");
        this.__showLoadingScene = new ObservedPropertySimplePU(false, this, "showLoadingScene");
        this.__videoUrl = new ObservedPropertySimplePU('', this, "videoUrl");
        this.controller = new TabsController();
        this.__gridMargin = new ObservedPropertySimplePU(10, this, "gridMargin");
        this.__gridGutter = new ObservedPropertySimplePU(10, this, "gridGutter");
        this.__sm = new ObservedPropertySimplePU(-2, this, "sm");
        this.__tabSelectIndex = new ObservedPropertySimplePU(0, this, "tabSelectIndex");
        this.__seekType = new ObservedPropertySimplePU(SEEK_TYPE.NORMAL, this, "seekType");
        this.__switchedToSoft = new ObservedPropertySimplePU(false, this, "switchedToSoft");
        this.__enableBackStagePlayback = new ObservedPropertySimplePU(false, this, "enableBackStagePlayback");
        this.__userPaused = new ObservedPropertySimplePU(false, this, "userPaused");
        this.backStaged = false;
        this.aliPlayerIndex = VideoController.createAliPlayer(getContext(), null);
        this.playerConfig = new PlayerConfig();
        this.context = getContext(this);
        this.listener = mediaquery.matchMediaSync('(orientation: landscape)');
        this.mOnOperationClicked = {
            onClick: (type) => {
                if (type === TYPE_PLAYER) { // 播放play
                    this.userPaused = false;
                }
                else if (type === TYPE_PAUSE) { // 暂停pause
                    this.userPaused = true;
                }
                else if (type === TYPE_READY) { // 准备prepare
                    this.showFinishScene = false;
                    this.showLoadingScene = false;
                }
                else if (type === TYPE_STOP) { // 停止stop
                }
                else if (type === TYPE_CAPTURE) { // 截屏snapshot
                }
            }
        };
        this.mOnBackStagePlaybackToggled = {
            onToggleChange: (isOn: boolean) => {
                this.enableBackStagePlayback = isOn;
                isOn ? this.requireBackStageTask() : this.releaseBackStageTask();
                if (isOn) {
                    // TODO: 开启后台任务还要执行什么吗？
                }
            }
        };
        this.setInitiallyProvidedValue(params);
    }
    setInitiallyProvidedValue(params: PlayerPage_Params) {
        if (params.mDialogController !== undefined) {
            this.mDialogController = params.mDialogController;
        }
        if (params.mUrlListListener !== undefined) {
            this.mUrlListListener = params.mUrlListListener;
        }
        if (params.mOnFullscreenToggled !== undefined) {
            this.mOnFullscreenToggled = params.mOnFullscreenToggled;
        }
        if (params.mOnSwitchedToSoft !== undefined) {
            this.mOnSwitchedToSoft = params.mOnSwitchedToSoft;
        }
        if (params.isFullScreen !== undefined) {
            this.isFullScreen = params.isFullScreen;
        }
        if (params.showFinishScene !== undefined) {
            this.showFinishScene = params.showFinishScene;
        }
        if (params.showLoadingScene !== undefined) {
            this.showLoadingScene = params.showLoadingScene;
        }
        if (params.videoUrl !== undefined) {
            this.videoUrl = params.videoUrl;
        }
        if (params.controller !== undefined) {
            this.controller = params.controller;
        }
        if (params.gridMargin !== undefined) {
            this.gridMargin = params.gridMargin;
        }
        if (params.gridGutter !== undefined) {
            this.gridGutter = params.gridGutter;
        }
        if (params.sm !== undefined) {
            this.sm = params.sm;
        }
        if (params.tabSelectIndex !== undefined) {
            this.tabSelectIndex = params.tabSelectIndex;
        }
        if (params.seekType !== undefined) {
            this.seekType = params.seekType;
        }
        if (params.switchedToSoft !== undefined) {
            this.switchedToSoft = params.switchedToSoft;
        }
        if (params.enableBackStagePlayback !== undefined) {
            this.enableBackStagePlayback = params.enableBackStagePlayback;
        }
        if (params.userPaused !== undefined) {
            this.userPaused = params.userPaused;
        }
        if (params.backStaged !== undefined) {
            this.backStaged = params.backStaged;
        }
        if (params.aliPlayerIndex !== undefined) {
            this.aliPlayerIndex = params.aliPlayerIndex;
        }
        if (params.playerConfig !== undefined) {
            this.playerConfig = params.playerConfig;
        }
        if (params.context !== undefined) {
            this.context = params.context;
        }
        if (params.listener !== undefined) {
            this.listener = params.listener;
        }
        if (params.mOnOperationClicked !== undefined) {
            this.mOnOperationClicked = params.mOnOperationClicked;
        }
        if (params.mOnBackStagePlaybackToggled !== undefined) {
            this.mOnBackStagePlaybackToggled = params.mOnBackStagePlaybackToggled;
        }
    }
    updateStateVars(params: PlayerPage_Params) {
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
        this.__isFullScreen.purgeDependencyOnElmtId(rmElmtId);
        this.__showFinishScene.purgeDependencyOnElmtId(rmElmtId);
        this.__showLoadingScene.purgeDependencyOnElmtId(rmElmtId);
        this.__videoUrl.purgeDependencyOnElmtId(rmElmtId);
        this.__gridMargin.purgeDependencyOnElmtId(rmElmtId);
        this.__gridGutter.purgeDependencyOnElmtId(rmElmtId);
        this.__sm.purgeDependencyOnElmtId(rmElmtId);
        this.__tabSelectIndex.purgeDependencyOnElmtId(rmElmtId);
        this.__seekType.purgeDependencyOnElmtId(rmElmtId);
        this.__switchedToSoft.purgeDependencyOnElmtId(rmElmtId);
        this.__enableBackStagePlayback.purgeDependencyOnElmtId(rmElmtId);
        this.__userPaused.purgeDependencyOnElmtId(rmElmtId);
    }
    aboutToBeDeleted() {
        this.__isFullScreen.aboutToBeDeleted();
        this.__showFinishScene.aboutToBeDeleted();
        this.__showLoadingScene.aboutToBeDeleted();
        this.__videoUrl.aboutToBeDeleted();
        this.__gridMargin.aboutToBeDeleted();
        this.__gridGutter.aboutToBeDeleted();
        this.__sm.aboutToBeDeleted();
        this.__tabSelectIndex.aboutToBeDeleted();
        this.__seekType.aboutToBeDeleted();
        this.__switchedToSoft.aboutToBeDeleted();
        this.__enableBackStagePlayback.aboutToBeDeleted();
        this.__userPaused.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    private mDialogController: CustomDialogController;
    private mUrlListListener: onRightClickListener;
    private mOnFullscreenToggled?: OnFullscreenToggleListener;
    private mOnSwitchedToSoft?: OnSwitchedToSoftListener;
    private onFullScreenChanged() {
        window.getLastWindow(getContext(this)).then(wind => {
            this.isFullScreen = !this.isFullScreen;
            wind.setPreferredOrientation(this.isFullScreen ? window.Orientation.LANDSCAPE : window.Orientation.PORTRAIT);
            wind.setWindowSystemBarEnable(this.isFullScreen ? [] : ['status']);
        });
        /*window.getLastWindow(getContext(this)).then(wind => {
          wind.setPreferredOrientation(this.isFullScreen ? window.Orientation.LANDSCAPE : window.Orientation.PORTRAIT, (err) => {
            console.log("HOS DEMO", 'setPreferredOrientation: ' + err.code);
          })
          wind.setWindowSystemBarEnable(this.isFullScreen ? [] : ['status']);
        });*/
    }
    private __isFullScreen: ObservedPropertySimplePU<boolean>;
    get isFullScreen() {
        return this.__isFullScreen.get();
    }
    set isFullScreen(newValue: boolean) {
        this.__isFullScreen.set(newValue);
    }
    private __showFinishScene: ObservedPropertySimplePU<boolean>;
    get showFinishScene() {
        return this.__showFinishScene.get();
    }
    set showFinishScene(newValue: boolean) {
        this.__showFinishScene.set(newValue);
    }
    private __showLoadingScene: ObservedPropertySimplePU<boolean>;
    get showLoadingScene() {
        return this.__showLoadingScene.get();
    }
    set showLoadingScene(newValue: boolean) {
        this.__showLoadingScene.set(newValue);
    }
    private __videoUrl: ObservedPropertySimplePU<string>;
    get videoUrl() {
        return this.__videoUrl.get();
    }
    set videoUrl(newValue: string) {
        this.__videoUrl.set(newValue);
    }
    private controller: TabsController;
    private __gridMargin: ObservedPropertySimplePU<number>;
    get gridMargin() {
        return this.__gridMargin.get();
    }
    set gridMargin(newValue: number) {
        this.__gridMargin.set(newValue);
    }
    private __gridGutter: ObservedPropertySimplePU<number>;
    get gridGutter() {
        return this.__gridGutter.get();
    }
    set gridGutter(newValue: number) {
        this.__gridGutter.set(newValue);
    }
    private __sm: ObservedPropertySimplePU<number>;
    get sm() {
        return this.__sm.get();
    }
    set sm(newValue: number) {
        this.__sm.set(newValue);
    }
    private __tabSelectIndex: ObservedPropertySimplePU<number>;
    get tabSelectIndex() {
        return this.__tabSelectIndex.get();
    }
    set tabSelectIndex(newValue: number) {
        this.__tabSelectIndex.set(newValue);
    }
    private __seekType: ObservedPropertySimplePU<SEEK_TYPE>;
    get seekType() {
        return this.__seekType.get();
    }
    set seekType(newValue: SEEK_TYPE) {
        this.__seekType.set(newValue);
    }
    private __switchedToSoft: ObservedPropertySimplePU<boolean>;
    get switchedToSoft() {
        return this.__switchedToSoft.get();
    }
    set switchedToSoft(newValue: boolean) {
        this.__switchedToSoft.set(newValue);
    }
    private __enableBackStagePlayback: ObservedPropertySimplePU<boolean>;
    get enableBackStagePlayback() {
        return this.__enableBackStagePlayback.get();
    }
    set enableBackStagePlayback(newValue: boolean) {
        this.__enableBackStagePlayback.set(newValue);
    }
    private __userPaused: ObservedPropertySimplePU<boolean>;
    get userPaused() {
        return this.__userPaused.get();
    }
    set userPaused(newValue: boolean) {
        this.__userPaused.set(newValue);
    }
    private backStaged: boolean;
    private aliPlayerIndex: number;
    private playerConfig: PlayerConfig;
    private context: Context;
    private listener;
    // 完全不能用 旋转触发不应该触发的事件
    /*private rotateListener(mediaQueryResult: mediaquery.MediaQueryResult) {
      showToast(JSON.stringify(mediaQueryResult));
      if (mediaQueryResult.matches as boolean) {  // 横屏
        showToast('match' + this.isFullScreen);
        if (this.isFullScreen === false) { // 还未全屏 此时该全屏
          this.mOnFullscreenToggled?.onFullscreenToggled();
        }
      } else { // 竖屏
        showToast('match fail' + this.isFullScreen);
        if (this.isFullScreen === true) { // 已经全屏了 此时该退出
          this.mOnFullscreenToggled?.onFullscreenToggled();
        }
      }
    }*/
    private mOnOperationClicked: OnButtonCLicked;
    private mOnBackStagePlaybackToggled: OnToggleListener;
    private requireBackStageTask() {
        // showToast("请求后台任务")
        let wantAgentInfo: wantAgent.WantAgentInfo = {
            // 点击通知后，将要执行的动作列表
            // 添加需要被拉起应用的bundleName和abilityName
            wants: [
                {
                    bundleName: "com.aliyun.player.ohos_demo",
                    abilityName: "EntryAbility"
                }
            ],
            // 指定点击通知栏消息后的动作是拉起ability
            operationType: wantAgent.OperationType.START_ABILITY,
            // 使用者自定义的一个私有值
            requestCode: 0,
            // 点击通知后，动作执行属性
            wantAgentFlags: [wantAgent.WantAgentFlags.UPDATE_PRESENT_FLAG]
        };
        // showToast("声明 wantInfo")
        // 通过wantAgent模块下getWantAgent方法获取WantAgent对象
        wantAgent.getWantAgent(wantAgentInfo).then((wantAgentObj: WantAgent) => {
            showToast("get want success");
            backgroundTaskManager.startBackgroundRunning(this.context, backgroundTaskManager.BackgroundMode.AUDIO_PLAYBACK, wantAgentObj).then(() => {
                showToast("background playback");
            }).catch((err: BusinessError) => {
                showToast("start background failed " + err.message);
                console.error(`Failed to operation startBackgroundRunning. Code is ${err.code}, message is ${err.message}`);
            });
        }).catch((err: BusinessError) => {
            showToast("get want failed " + err.message);
        });
    }
    private releaseBackStageTask() {
        showToast("关闭后台任务");
        backgroundTaskManager.stopBackgroundRunning(this.context).then(() => {
            console.info(`Succeeded in operationing stopBackgroundRunning.`);
        }).catch((err: BusinessError) => {
            console.error(`Failed to operation stopBackgroundRunning. Code is ${err.code}, message is ${err.message}`);
        });
    }
    aboutToAppear() {
        let params: object = router.getParams();
        this.videoUrl = params['videoUrl'];
        showToast(this.videoUrl);
        log.i('aboutToAppear, videoUrl: ' + this.videoUrl);
        // let rotateFunction = (mediaQueryResult:mediaquery.MediaQueryResult): void => this.rotateListener(mediaQueryResult)
        // this.listener.on('change', rotateFunction);
        window.getLastWindow(getContext(this)).then(wind => {
            wind.setPreferredOrientation(window.Orientation.PORTRAIT, (err) => { }); // 设置自动响应
        });
    }
    aboutToDisappear() {
        VideoController.getPlayer(this.aliPlayerIndex)?.stop();
        VideoController.dispose(this.aliPlayerIndex);
        log.i('aboutToDisappear, player has been released.');
        window.getLastWindow(getContext(this)).then(wind => {
            wind.setWindowBrightness(-1).then((res) => { });
        });
    }
    onBackPress() {
        // showToast('on back press');
        if (this.isFullScreen) {
            this.mOnFullscreenToggled?.onFullscreenToggled();
            return true; // 只退出全屏
        }
        else {
            return false; // 返回上一级
        }
    }
    onPageHide(): void {
        if (!this.enableBackStagePlayback) {
            VideoController.getPlayer(this.aliPlayerIndex)?.pause();
            this.backStaged = true;
        }
    }
    onPageShow(): void {
        if (!this.enableBackStagePlayback && this.backStaged && !this.userPaused) {
            VideoController.getPlayer(this.aliPlayerIndex)?.start();
            this.backStaged = false;
        }
    }
    initialRender() {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Row.create();
            Row.height('100%');
            Row.alignItems(VerticalAlign.Top);
        }, Row);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Column.create();
            Column.width('100%');
        }, Column);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            If.create();
            if (!this.isFullScreen) {
                this.ifElseBranchUpdateFunction(0, () => {
                    {
                        this.observeComponentCreation2((elmtId, isInitialRender) => {
                            if (isInitialRender) {
                                let paramsLambda = () => {
                                    return {
                                        title: '播放',
                                        rightTitle: 'URL列表',
                                        rightListener: this.mUrlListListener
                                    };
                                };
                                ViewPU.create(new HeaderComponent(this, { title: '播放', rightTitle: 'URL列表', rightListener: this.mUrlListListener }, undefined, elmtId, paramsLambda, { page: "amdemos-player-ohos-listapp/src/main/ets/pages/PlayerPage.ets", line: 237 }));
                            }
                            else {
                                this.updateStateVarsOfChildByElmtId(elmtId, {});
                            }
                        }, { name: "HeaderComponent" });
                    }
                });
            }
            else {
                this.ifElseBranchUpdateFunction(1, () => {
                });
            }
        }, If);
        If.pop();
        {
            this.observeComponentCreation2((elmtId, isInitialRender) => {
                if (isInitialRender) {
                    let paramsLambda = () => {
                        return {
                            videoUrl: this.videoUrl,
                            playerIndex: this.aliPlayerIndex,
                            mFullscreenListener: this.mOnFullscreenToggled,
                            isFullScreen: this.isFullScreen,
                            seekType: this.seekType,
                            mSwitchedToSoftListener: this.mOnSwitchedToSoft,
                            showFinishScene: this.showFinishScene,
                            showLoadingScene: this.showLoadingScene
                        };
                    };
                    ViewPU.create(new VideoComponent(this, {
                        videoUrl: this.videoUrl,
                        playerIndex: this.aliPlayerIndex,
                        mFullscreenListener: this.mOnFullscreenToggled,
                        isFullScreen: this.__isFullScreen,
                        seekType: this.__seekType,
                        mSwitchedToSoftListener: this.mOnSwitchedToSoft,
                        showFinishScene: this.__showFinishScene,
                        showLoadingScene: this.__showLoadingScene
                    }, undefined, elmtId, paramsLambda, { page: "amdemos-player-ohos-listapp/src/main/ets/pages/PlayerPage.ets", line: 239 }));
                }
                else {
                    this.updateStateVarsOfChildByElmtId(elmtId, {
                        playerIndex: this.aliPlayerIndex
                    });
                }
            }, { name: "VideoComponent" });
        }
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            If.create();
            if (!this.isFullScreen) {
                this.ifElseBranchUpdateFunction(0, () => {
                    this.observeComponentCreation2((elmtId, isInitialRender) => {
                        Row.create();
                        Row.justifyContent(FlexAlign.Center);
                    }, Row);
                    this.observeComponentCreation2((elmtId, isInitialRender) => {
                        __Common__.create();
                        __Common__.width('20%');
                    }, __Common__);
                    {
                        this.observeComponentCreation2((elmtId, isInitialRender) => {
                            if (isInitialRender) {
                                let paramsLambda = () => {
                                    return {
                                        title: '准备',
                                        buttonType: TYPE_READY,
                                        playerIndex: this.aliPlayerIndex,
                                        mOnButtonClicked: this.mOnOperationClicked
                                    };
                                };
                                ViewPU.create(new NormalButton(this, { title: '准备', buttonType: TYPE_READY, playerIndex: this.aliPlayerIndex, mOnButtonClicked: this.mOnOperationClicked }, undefined, elmtId, paramsLambda, { page: "amdemos-player-ohos-listapp/src/main/ets/pages/PlayerPage.ets", line: 251 }));
                            }
                            else {
                                this.updateStateVarsOfChildByElmtId(elmtId, {
                                    playerIndex: this.aliPlayerIndex
                                });
                            }
                        }, { name: "NormalButton" });
                    }
                    __Common__.pop();
                    this.observeComponentCreation2((elmtId, isInitialRender) => {
                        __Common__.create();
                        __Common__.width('20%');
                    }, __Common__);
                    {
                        this.observeComponentCreation2((elmtId, isInitialRender) => {
                            if (isInitialRender) {
                                let paramsLambda = () => {
                                    return {
                                        title: '播放',
                                        buttonType: TYPE_PLAYER,
                                        playerIndex: this.aliPlayerIndex,
                                        mOnButtonClicked: this.mOnOperationClicked
                                    };
                                };
                                ViewPU.create(new NormalButton(this, { title: '播放', buttonType: TYPE_PLAYER, playerIndex: this.aliPlayerIndex, mOnButtonClicked: this.mOnOperationClicked }, undefined, elmtId, paramsLambda, { page: "amdemos-player-ohos-listapp/src/main/ets/pages/PlayerPage.ets", line: 252 }));
                            }
                            else {
                                this.updateStateVarsOfChildByElmtId(elmtId, {
                                    playerIndex: this.aliPlayerIndex
                                });
                            }
                        }, { name: "NormalButton" });
                    }
                    __Common__.pop();
                    this.observeComponentCreation2((elmtId, isInitialRender) => {
                        __Common__.create();
                        __Common__.width('20%');
                    }, __Common__);
                    {
                        this.observeComponentCreation2((elmtId, isInitialRender) => {
                            if (isInitialRender) {
                                let paramsLambda = () => {
                                    return {
                                        title: '停止',
                                        buttonType: TYPE_STOP,
                                        playerIndex: this.aliPlayerIndex,
                                        mOnButtonClicked: this.mOnOperationClicked
                                    };
                                };
                                ViewPU.create(new NormalButton(this, { title: '停止', buttonType: TYPE_STOP, playerIndex: this.aliPlayerIndex, mOnButtonClicked: this.mOnOperationClicked }, undefined, elmtId, paramsLambda, { page: "amdemos-player-ohos-listapp/src/main/ets/pages/PlayerPage.ets", line: 253 }));
                            }
                            else {
                                this.updateStateVarsOfChildByElmtId(elmtId, {
                                    playerIndex: this.aliPlayerIndex
                                });
                            }
                        }, { name: "NormalButton" });
                    }
                    __Common__.pop();
                    this.observeComponentCreation2((elmtId, isInitialRender) => {
                        __Common__.create();
                        __Common__.width('20%');
                    }, __Common__);
                    {
                        this.observeComponentCreation2((elmtId, isInitialRender) => {
                            if (isInitialRender) {
                                let paramsLambda = () => {
                                    return {
                                        title: '暂停',
                                        buttonType: TYPE_PAUSE,
                                        playerIndex: this.aliPlayerIndex,
                                        mOnButtonClicked: this.mOnOperationClicked
                                    };
                                };
                                ViewPU.create(new NormalButton(this, { title: '暂停', buttonType: TYPE_PAUSE, playerIndex: this.aliPlayerIndex, mOnButtonClicked: this.mOnOperationClicked }, undefined, elmtId, paramsLambda, { page: "amdemos-player-ohos-listapp/src/main/ets/pages/PlayerPage.ets", line: 254 }));
                            }
                            else {
                                this.updateStateVarsOfChildByElmtId(elmtId, {
                                    playerIndex: this.aliPlayerIndex
                                });
                            }
                        }, { name: "NormalButton" });
                    }
                    __Common__.pop();
                    this.observeComponentCreation2((elmtId, isInitialRender) => {
                        __Common__.create();
                        __Common__.width('20%');
                    }, __Common__);
                    {
                        this.observeComponentCreation2((elmtId, isInitialRender) => {
                            if (isInitialRender) {
                                let paramsLambda = () => {
                                    return {
                                        title: '截图',
                                        buttonType: TYPE_CAPTURE,
                                        playerIndex: this.aliPlayerIndex,
                                        mOnButtonClicked: this.mOnOperationClicked
                                    };
                                };
                                ViewPU.create(new NormalButton(this, { title: '截图', buttonType: TYPE_CAPTURE, playerIndex: this.aliPlayerIndex, mOnButtonClicked: this.mOnOperationClicked }, undefined, elmtId, paramsLambda, { page: "amdemos-player-ohos-listapp/src/main/ets/pages/PlayerPage.ets", line: 255 }));
                            }
                            else {
                                this.updateStateVarsOfChildByElmtId(elmtId, {
                                    playerIndex: this.aliPlayerIndex
                                });
                            }
                        }, { name: "NormalButton" });
                    }
                    __Common__.pop();
                    Row.pop();
                    this.observeComponentCreation2((elmtId, isInitialRender) => {
                        // tab切换页
                        Tabs.create({ barPosition: BarPosition.End, index: this.tabSelectIndex, controller: this.controller });
                        // tab切换页
                        Tabs.scrollable(false);
                        // tab切换页
                        Tabs.width('100%');
                        // tab切换页
                        Tabs.height('60%');
                        // tab切换页
                        Tabs.onTabBarClick((index: number) => {
                            this.tabSelectIndex = index;
                            // this.controller.changeIndex(index);
                        });
                    }, Tabs);
                    this.observeComponentCreation2((elmtId, isInitialRender) => {
                        TabContent.create(() => {
                            this.observeComponentCreation2((elmtId, isInitialRender) => {
                                Column.create();
                                Column.width('100%');
                                Column.height('100%');
                                Column.backgroundColor(0xeeeeee);
                            }, Column);
                            {
                                this.observeComponentCreation2((elmtId, isInitialRender) => {
                                    if (isInitialRender) {
                                        let paramsLambda = () => {
                                            return {
                                                playerIndex: this.aliPlayerIndex,
                                                seekType: this.seekType,
                                                switchedToSoft: this.switchedToSoft,
                                                enableBackStagePlayback: this.enableBackStagePlayback,
                                                mOnBackStagePlaybackToggled: this.mOnBackStagePlaybackToggled
                                            };
                                        };
                                        ViewPU.create(new OptionsTabComponent(this, {
                                            playerIndex: this.aliPlayerIndex,
                                            seekType: this.__seekType,
                                            switchedToSoft: this.switchedToSoft,
                                            enableBackStagePlayback: this.__enableBackStagePlayback,
                                            mOnBackStagePlaybackToggled: this.mOnBackStagePlaybackToggled
                                        }, undefined, elmtId, paramsLambda, { page: "amdemos-player-ohos-listapp/src/main/ets/pages/PlayerPage.ets", line: 262 }));
                                    }
                                    else {
                                        this.updateStateVarsOfChildByElmtId(elmtId, {
                                            playerIndex: this.aliPlayerIndex,
                                            switchedToSoft: this.switchedToSoft,
                                            mOnBackStagePlaybackToggled: this.mOnBackStagePlaybackToggled
                                        });
                                    }
                                }, { name: "OptionsTabComponent" });
                            }
                            Column.pop();
                        });
                        TabContent.tabBar({ builder: () => {
                                this.TabBuilder.call(this, "options", 0);
                            } });
                    }, TabContent);
                    TabContent.pop();
                    this.observeComponentCreation2((elmtId, isInitialRender) => {
                        TabContent.create(() => {
                            this.observeComponentCreation2((elmtId, isInitialRender) => {
                                Column.create();
                                Column.width('100%');
                                Column.height('100%');
                                Column.backgroundColor(0xeeeeee);
                            }, Column);
                            {
                                this.observeComponentCreation2((elmtId, isInitialRender) => {
                                    if (isInitialRender) {
                                        let paramsLambda = () => {
                                            return {
                                                playerIndex: this.aliPlayerIndex
                                            };
                                        };
                                        ViewPU.create(new PlayerConfigTabComponent(this, { playerIndex: this.aliPlayerIndex }, undefined, elmtId, paramsLambda, { page: "amdemos-player-ohos-listapp/src/main/ets/pages/PlayerPage.ets", line: 274 }));
                                    }
                                    else {
                                        this.updateStateVarsOfChildByElmtId(elmtId, {
                                            playerIndex: this.aliPlayerIndex
                                        });
                                    }
                                }, { name: "PlayerConfigTabComponent" });
                            }
                            Column.pop();
                        });
                        TabContent.tabBar({ builder: () => {
                                this.TabBuilder.call(this, "player_cfg", 1);
                            } });
                    }, TabContent);
                    TabContent.pop();
                    this.observeComponentCreation2((elmtId, isInitialRender) => {
                        TabContent.create(() => {
                            this.observeComponentCreation2((elmtId, isInitialRender) => {
                                Column.create();
                                Column.width('100%');
                                Column.height('100%');
                                Column.backgroundColor(0xeeeeee);
                            }, Column);
                            Column.pop();
                        });
                        TabContent.tabBar({ builder: () => {
                                this.TabBuilder.call(this, "filter", 2);
                            } });
                    }, TabContent);
                    TabContent.pop();
                    this.observeComponentCreation2((elmtId, isInitialRender) => {
                        TabContent.create(() => {
                            this.observeComponentCreation2((elmtId, isInitialRender) => {
                                Column.create();
                                Column.width('100%');
                                Column.height('100%');
                                Column.backgroundColor(0xeeeeee);
                            }, Column);
                            Column.pop();
                        });
                        TabContent.tabBar({ builder: () => {
                                this.TabBuilder.call(this, "cache_cfg", 3);
                            } });
                    }, TabContent);
                    TabContent.pop();
                    this.observeComponentCreation2((elmtId, isInitialRender) => {
                        TabContent.create(() => {
                            this.observeComponentCreation2((elmtId, isInitialRender) => {
                                Column.create();
                                Column.width('100%');
                                Column.height('100%');
                                Column.backgroundColor(0xeeeeee);
                            }, Column);
                            Column.pop();
                        });
                        TabContent.tabBar({ builder: () => {
                                this.TabBuilder.call(this, "track", 4);
                            } });
                    }, TabContent);
                    TabContent.pop();
                    // tab切换页
                    Tabs.pop();
                });
            }
            else {
                this.ifElseBranchUpdateFunction(1, () => {
                });
            }
        }, If);
        If.pop();
        Column.pop();
        Row.pop();
    }
    TabBuilder(name: string, index?: number, parent = null) {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Column.create();
            Column.width('100%');
            Column.height('40vp');
            Column.backgroundColor(0xffffff);
            Column.justifyContent(FlexAlign.Center);
        }, Column);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Text.create(name);
            Text.fontSize(14);
            Text.fontColor(this.tabSelectIndex === index ? { "id": 16777226, "type": 10001, params: [], "bundleName": "com.aliyun.player.ohos_demo", "moduleName": "listapp" } : { "id": 16777225, "type": 10001, params: [], "bundleName": "com.aliyun.player.ohos_demo", "moduleName": "listapp" });
        }, Text);
        Text.pop();
        Column.pop();
    }
    rerender() {
        this.updateDirtyElements();
    }
    static getEntryName(): string {
        return "PlayerPage";
    }
}
class ToggleCommponent extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1, paramsLambda = undefined, extraInfo) {
        super(parent, __localStorage, elmtId, extraInfo);
        if (typeof paramsLambda === "function") {
            this.paramsGenerator_ = paramsLambda;
        }
        this.mListener = undefined;
        this.__title = new ObservedPropertySimplePU('', this, "title");
        this.__lockState = new SynchedPropertySimpleOneWayPU(params.lockState, this, "lockState");
        this.setInitiallyProvidedValue(params);
    }
    setInitiallyProvidedValue(params: ToggleCommponent_Params) {
        if (params.mListener !== undefined) {
            this.mListener = params.mListener;
        }
        if (params.title !== undefined) {
            this.title = params.title;
        }
        if (params.lockState === undefined) {
            this.__lockState.set(undefined);
        }
    }
    updateStateVars(params: ToggleCommponent_Params) {
        this.__lockState.reset(params.lockState);
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
        this.__title.purgeDependencyOnElmtId(rmElmtId);
        this.__lockState.purgeDependencyOnElmtId(rmElmtId);
    }
    aboutToBeDeleted() {
        this.__title.aboutToBeDeleted();
        this.__lockState.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    private mListener?: OnToggleListener;
    private __title: ObservedPropertySimplePU<string>;
    get title() {
        return this.__title.get();
    }
    set title(newValue: string) {
        this.__title.set(newValue);
    }
    private __lockState?: SynchedPropertySimpleOneWayPU<boolean | undefined>;
    get lockState() {
        return this.__lockState.get();
    }
    set lockState(newValue: boolean | undefined) {
        this.__lockState.set(newValue);
    }
    initialRender() {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Column.create();
            Column.width('100%');
        }, Column);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Toggle.create({ type: ToggleType.Switch, isOn: !!this.lockState });
            Toggle.enabled((this.lockState !== true && this.lockState !== false));
            Toggle.selectedColor('$r(app.color.item_select_bg)');
            Toggle.switchPointColor('#FFFFFF');
            Toggle.onChange((isOn: boolean) => {
                this.mListener?.onToggleChange(isOn);
            });
        }, Toggle);
        Toggle.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Text.create(this.title);
            Text.fontSize(14);
        }, Text);
        Text.pop();
        Column.pop();
    }
    rerender() {
        this.updateDirtyElements();
    }
}
class NormalButton extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1, paramsLambda = undefined, extraInfo) {
        super(parent, __localStorage, elmtId, extraInfo);
        if (typeof paramsLambda === "function") {
            this.paramsGenerator_ = paramsLambda;
        }
        this.__title = new ObservedPropertySimplePU('', this, "title");
        this.__playerIndex = new SynchedPropertySimpleOneWayPU(params.playerIndex, this, "playerIndex");
        this.mOnButtonClicked = undefined;
        this.buttonType = 0;
        this.setInitiallyProvidedValue(params);
    }
    setInitiallyProvidedValue(params: NormalButton_Params) {
        if (params.title !== undefined) {
            this.title = params.title;
        }
        if (params.playerIndex === undefined) {
            this.__playerIndex.set(-1);
        }
        if (params.mOnButtonClicked !== undefined) {
            this.mOnButtonClicked = params.mOnButtonClicked;
        }
        if (params.buttonType !== undefined) {
            this.buttonType = params.buttonType;
        }
    }
    updateStateVars(params: NormalButton_Params) {
        this.__playerIndex.reset(params.playerIndex);
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
        this.__title.purgeDependencyOnElmtId(rmElmtId);
        this.__playerIndex.purgeDependencyOnElmtId(rmElmtId);
    }
    aboutToBeDeleted() {
        this.__title.aboutToBeDeleted();
        this.__playerIndex.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    private __title: ObservedPropertySimplePU<string>;
    get title() {
        return this.__title.get();
    }
    set title(newValue: string) {
        this.__title.set(newValue);
    }
    private __playerIndex: SynchedPropertySimpleOneWayPU<number>;
    get playerIndex() {
        return this.__playerIndex.get();
    }
    set playerIndex(newValue: number) {
        this.__playerIndex.set(newValue);
    }
    private mOnButtonClicked?: OnButtonCLicked;
    private buttonType: number;
    initialRender() {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Button.createWithLabel(this.title, { type: ButtonType.Normal, stateEffect: true });
            Button.backgroundColor(0xFFFFFF);
            Button.fontColor(0x0000CC);
            Button.width('100%');
            Button.onClick(() => {
                log.i(this.title + ',buttonType: ' + this.buttonType);
                switch (this.buttonType) {
                    case TYPE_READY:
                        console.log("[HOS DEMO] onclick prepare", this.playerIndex, VideoController.getPlayer(this.playerIndex));
                        VideoController.getPlayer(this.playerIndex)?.prepare();
                        this.mOnButtonClicked?.onClick(TYPE_READY);
                        showToast("PREPARE " + this.playerIndex);
                        break;
                    case TYPE_PLAYER:
                        VideoController.getPlayer(this.playerIndex)?.start();
                        showToast("START");
                        this.mOnButtonClicked?.onClick(TYPE_PLAYER);
                        break;
                    case TYPE_STOP:
                        VideoController.getPlayer(this.playerIndex)?.stop();
                        this.mOnButtonClicked?.onClick(TYPE_STOP);
                        // showToast("STOP");
                        break;
                    case TYPE_PAUSE:
                        VideoController.getPlayer(this.playerIndex)?.pause();
                        this.mOnButtonClicked?.onClick(TYPE_PAUSE);
                        showToast("PAUSE");
                        break;
                    case TYPE_CAPTURE:
                        this.mOnButtonClicked?.onClick(TYPE_CAPTURE);
                        break;
                }
            });
        }, Button);
        Button.pop();
    }
    rerender() {
        this.updateDirtyElements();
    }
}
class OptionsTabComponent extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1, paramsLambda = undefined, extraInfo) {
        super(parent, __localStorage, elmtId, extraInfo);
        if (typeof paramsLambda === "function") {
            this.paramsGenerator_ = paramsLambda;
        }
        this.__volume = this.createStorageProp(LOCAL_PROP_KEY_VOLUME, 0, "volume");
        this.__mBackgroundColor = new ObservedPropertySimplePU('', this, "mBackgroundColor");
        this.__mBitBandWidth = new ObservedPropertySimplePU('', this, "mBitBandWidth");
        this.__playerIndex = new SynchedPropertySimpleOneWayPU(params.playerIndex, this, "playerIndex");
        this.__hardwareDecodedEnableLocked = this.createStorageProp(LOCAL_PROP_KEY_HARDWARE_DECODE_ENABLED, false, "hardwareDecodedEnableLocked");
        this.__switchedToSoft = new SynchedPropertySimpleOneWayPU(params.switchedToSoft, this, "switchedToSoft");
        this.__seekType = new SynchedPropertySimpleTwoWayPU(params.seekType, this, "seekType");
        this.__enableBackStagePlayback = new SynchedPropertySimpleTwoWayPU(params.enableBackStagePlayback, this, "enableBackStagePlayback");
        this.__mOnBackStagePlaybackToggled = new SynchedPropertyObjectOneWayPU(params.mOnBackStagePlaybackToggled, this, "mOnBackStagePlaybackToggled");
        this.scroller = new Scroller();
        this.mMultiplyPlayback = {
            onSelectChanged: (selectIndex: number) => {
                let speed: number = 1;
                switch (selectIndex) {
                    case 0: // 正常播放速度
                        speed = 1;
                        break;
                    case 1: // 0.5倍速
                        speed = 0.5;
                        break;
                    case 2: // 1.5倍速
                        speed = 1.5;
                        break;
                    case 3: // 2.0倍速
                        speed = 2.0;
                        break;
                    case 4: // 5.0倍速
                        speed = 5.0;
                        break;
                }
                VideoController.getPlayer(this.playerIndex)?.setSpeed(speed);
            }
        };
        this.mScaleModePlayBack = {
            onSelectChanged: (selectIndex: number) => {
                let scaleMode: ScaleMode = ScaleMode.SCALE_ASPECT_FIT;
                switch (selectIndex) {
                    case 0: //比例填充
                        scaleMode = ScaleMode.SCALE_ASPECT_FIT;
                        break;
                    case 1: //比例全屏
                        scaleMode = ScaleMode.SCALE_ASPECT_FILL;
                        break;
                    case 2: //拉伸全屏
                        scaleMode = ScaleMode.SCALE_TO_FILL;
                        break;
                }
                VideoController.getPlayer(this.playerIndex)?.setScaleMode(scaleMode);
            }
        };
        this.mMirrorModePlayBack = {
            onSelectChanged: (selectIndex: number) => {
                let mirrorMode: MirrorMode = MirrorMode.MIRROR_MODE_NONE;
                switch (selectIndex) {
                    case 0: //无镜像
                        mirrorMode = MirrorMode.MIRROR_MODE_NONE;
                        break;
                    case 1: //水平镜像
                        mirrorMode = MirrorMode.MIRROR_MODE_HORIZONTAL;
                        break;
                    case 2: //垂直镜像
                        mirrorMode = MirrorMode.MIRROR_MODE_VERTICAL;
                        break;
                }
                VideoController.getPlayer(this.playerIndex)?.setMirrorMode(mirrorMode);
            }
        };
        this.mRotateModePlayBack = {
            onSelectChanged: (selectIndex: number) => {
                let rotateMode: RotateMode = RotateMode.ROTATE_0;
                switch (selectIndex) {
                    case 0: //0°
                        rotateMode = RotateMode.ROTATE_0;
                        break;
                    case 1: //90°
                        rotateMode = RotateMode.ROTATE_90;
                        break;
                    case 2: //180°
                        rotateMode = RotateMode.ROTATE_180;
                        break;
                    case 3: //270°
                        rotateMode = RotateMode.ROTATE_270;
                        break;
                }
                VideoController.getPlayer(this.playerIndex)?.setRotateMode(rotateMode);
            }
        };
        this.mAutoplayToggleListener = {
            onToggleChange: (isOn: boolean) => {
                console.log("[HOS DEMO]: PLAYERPAGE", "toggle autoplay", isOn, VideoController.getPlayer(this.playerIndex));
                showToast("autoplay " + isOn + " " + this.playerIndex);
                VideoController.getPlayer(this.playerIndex)?.setAutoPlay(isOn);
            }
        };
        this.mMuteToggleListener = {
            onToggleChange: (isOn: boolean) => {
                console.log("[HOS DEMO]: PLAYERPAGE", "toggle muted", isOn);
                VideoController.getPlayer(this.playerIndex)?.setMute(isOn);
            }
        };
        this.mLoopToggleListener = {
            onToggleChange: (isOn: boolean) => {
                console.log("[HOS DEMO]: PLAYERPAGE", "toggle loopplay", isOn);
                VideoController.getPlayer(this.playerIndex)?.setLoop(isOn);
            }
        };
        this.mHardwareDecodeToggleListener = {
            onToggleChange: (isOn: boolean) => {
                console.log("[HOS DEMO]: PLAYERPAGE", "toggle hardware decode", isOn);
                VideoController.getPlayer(this.playerIndex)?.enableHardwareDecoder(isOn);
            }
        };
        this.mAccurateSeekToggleListener = {
            onToggleChange: (isOn: boolean) => {
                console.log("[HOS DEMO]: PLAYERPAGE", "toggle accurate Seek", isOn);
                this.seekType = isOn ? SEEK_TYPE.ACCURATE : SEEK_TYPE.NORMAL;
            }
        };
        this.setInitiallyProvidedValue(params);
    }
    setInitiallyProvidedValue(params: OptionsTabComponent_Params) {
        if (params.mBackgroundColor !== undefined) {
            this.mBackgroundColor = params.mBackgroundColor;
        }
        if (params.mBitBandWidth !== undefined) {
            this.mBitBandWidth = params.mBitBandWidth;
        }
        if (params.playerIndex === undefined) {
            this.__playerIndex.set(-1);
        }
        if (params.scroller !== undefined) {
            this.scroller = params.scroller;
        }
        if (params.mMultiplyPlayback !== undefined) {
            this.mMultiplyPlayback = params.mMultiplyPlayback;
        }
        if (params.mScaleModePlayBack !== undefined) {
            this.mScaleModePlayBack = params.mScaleModePlayBack;
        }
        if (params.mMirrorModePlayBack !== undefined) {
            this.mMirrorModePlayBack = params.mMirrorModePlayBack;
        }
        if (params.mRotateModePlayBack !== undefined) {
            this.mRotateModePlayBack = params.mRotateModePlayBack;
        }
        if (params.mAutoplayToggleListener !== undefined) {
            this.mAutoplayToggleListener = params.mAutoplayToggleListener;
        }
        if (params.mMuteToggleListener !== undefined) {
            this.mMuteToggleListener = params.mMuteToggleListener;
        }
        if (params.mLoopToggleListener !== undefined) {
            this.mLoopToggleListener = params.mLoopToggleListener;
        }
        if (params.mHardwareDecodeToggleListener !== undefined) {
            this.mHardwareDecodeToggleListener = params.mHardwareDecodeToggleListener;
        }
        if (params.mAccurateSeekToggleListener !== undefined) {
            this.mAccurateSeekToggleListener = params.mAccurateSeekToggleListener;
        }
    }
    updateStateVars(params: OptionsTabComponent_Params) {
        this.__playerIndex.reset(params.playerIndex);
        this.__switchedToSoft.reset(params.switchedToSoft);
        this.__mOnBackStagePlaybackToggled.reset(params.mOnBackStagePlaybackToggled);
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
        this.__volume.purgeDependencyOnElmtId(rmElmtId);
        this.__mBackgroundColor.purgeDependencyOnElmtId(rmElmtId);
        this.__mBitBandWidth.purgeDependencyOnElmtId(rmElmtId);
        this.__playerIndex.purgeDependencyOnElmtId(rmElmtId);
        this.__hardwareDecodedEnableLocked.purgeDependencyOnElmtId(rmElmtId);
        this.__switchedToSoft.purgeDependencyOnElmtId(rmElmtId);
        this.__seekType.purgeDependencyOnElmtId(rmElmtId);
        this.__enableBackStagePlayback.purgeDependencyOnElmtId(rmElmtId);
        this.__mOnBackStagePlaybackToggled.purgeDependencyOnElmtId(rmElmtId);
    }
    aboutToBeDeleted() {
        this.__volume.aboutToBeDeleted();
        this.__mBackgroundColor.aboutToBeDeleted();
        this.__mBitBandWidth.aboutToBeDeleted();
        this.__playerIndex.aboutToBeDeleted();
        this.__hardwareDecodedEnableLocked.aboutToBeDeleted();
        this.__switchedToSoft.aboutToBeDeleted();
        this.__seekType.aboutToBeDeleted();
        this.__enableBackStagePlayback.aboutToBeDeleted();
        this.__mOnBackStagePlaybackToggled.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    private __volume: ObservedPropertyAbstractPU<number>;
    get volume() {
        return this.__volume.get();
    }
    set volume(newValue: number) {
        this.__volume.set(newValue);
    }
    private __mBackgroundColor: ObservedPropertySimplePU<string>;
    get mBackgroundColor() {
        return this.__mBackgroundColor.get();
    }
    set mBackgroundColor(newValue: string) {
        this.__mBackgroundColor.set(newValue);
    }
    private __mBitBandWidth: ObservedPropertySimplePU<string>;
    get mBitBandWidth() {
        return this.__mBitBandWidth.get();
    }
    set mBitBandWidth(newValue: string) {
        this.__mBitBandWidth.set(newValue);
    }
    private __playerIndex: SynchedPropertySimpleOneWayPU<number>;
    get playerIndex() {
        return this.__playerIndex.get();
    }
    set playerIndex(newValue: number) {
        this.__playerIndex.set(newValue);
    }
    private __hardwareDecodedEnableLocked: ObservedPropertyAbstractPU<boolean>;
    get hardwareDecodedEnableLocked() {
        return this.__hardwareDecodedEnableLocked.get();
    }
    set hardwareDecodedEnableLocked(newValue: boolean) {
        this.__hardwareDecodedEnableLocked.set(newValue);
    }
    private __switchedToSoft: SynchedPropertySimpleOneWayPU<boolean>;
    get switchedToSoft() {
        return this.__switchedToSoft.get();
    }
    set switchedToSoft(newValue: boolean) {
        this.__switchedToSoft.set(newValue);
    }
    private __seekType: SynchedPropertySimpleTwoWayPU<SEEK_TYPE>;
    get seekType() {
        return this.__seekType.get();
    }
    set seekType(newValue: SEEK_TYPE) {
        this.__seekType.set(newValue);
    }
    private __enableBackStagePlayback: SynchedPropertySimpleTwoWayPU<boolean>;
    get enableBackStagePlayback() {
        return this.__enableBackStagePlayback.get();
    }
    set enableBackStagePlayback(newValue: boolean) {
        this.__enableBackStagePlayback.set(newValue);
    }
    private __mOnBackStagePlaybackToggled?: SynchedPropertySimpleOneWayPU<OnToggleListener>;
    get mOnBackStagePlaybackToggled() {
        return this.__mOnBackStagePlaybackToggled.get();
    }
    set mOnBackStagePlaybackToggled(newValue: OnToggleListener) {
        this.__mOnBackStagePlaybackToggled.set(newValue);
    }
    private scroller: Scroller;
    private mMultiplyPlayback: OnSelectListener;
    private mScaleModePlayBack: OnSelectListener;
    private mMirrorModePlayBack: OnSelectListener;
    private mRotateModePlayBack: OnSelectListener;
    private mAutoplayToggleListener: OnToggleListener;
    private mMuteToggleListener: OnToggleListener;
    private mLoopToggleListener: OnToggleListener;
    private mHardwareDecodeToggleListener: OnToggleListener;
    private mAccurateSeekToggleListener: OnToggleListener;
    initialRender() {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Scroll.create(this.scroller);
            Scroll.height('100%');
            Scroll.scrollable(ScrollDirection.Vertical);
            Scroll.friction(0.6);
            Scroll.edgeEffect(EdgeEffect.None);
        }, Scroll);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Column.create();
            Column.alignItems(HorizontalAlign.Start);
            Column.padding({ bottom: 25 });
        }, Column);
        this.PlayerParams.bind(this)();
        this.VolumeSlider.bind(this)();
        this.SelectMode.bind(this)();
        this.BackgroundColor.bind(this)();
        this.BitBandWidth.bind(this)();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            __Common__.create();
            __Common__.width('20%');
            __Common__.margin({ top: 10 });
            __Common__.height(34);
        }, __Common__);
        {
            this.observeComponentCreation2((elmtId, isInitialRender) => {
                if (isInitialRender) {
                    let paramsLambda = () => {
                        return {
                            title: '后台播放',
                            mListener: this.mOnBackStagePlaybackToggled
                        };
                    };
                    ViewPU.create(new ToggleCommponent(this, { title: '后台播放', mListener: this.mOnBackStagePlaybackToggled }, undefined, elmtId, paramsLambda, { page: "amdemos-player-ohos-listapp/src/main/ets/pages/PlayerPage.ets", line: 506 }));
                }
                else {
                    this.updateStateVarsOfChildByElmtId(elmtId, {});
                }
            }, { name: "ToggleCommponent" });
        }
        __Common__.pop();
        Column.pop();
        Scroll.pop();
    }
    PlayerParams(parent = null) {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Row.create();
            Row.justifyContent(FlexAlign.Center);
            Row.margin({ top: 10 });
            Row.height(50);
        }, Row);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            __Common__.create();
            __Common__.width('20%');
        }, __Common__);
        {
            this.observeComponentCreation2((elmtId, isInitialRender) => {
                if (isInitialRender) {
                    let paramsLambda = () => {
                        return {
                            title: '自动播放',
                            mListener: this.mAutoplayToggleListener
                        };
                    };
                    ViewPU.create(new ToggleCommponent(this, { title: '自动播放', mListener: this.mAutoplayToggleListener }, undefined, elmtId, paramsLambda, { page: "amdemos-player-ohos-listapp/src/main/ets/pages/PlayerPage.ets", line: 518 }));
                }
                else {
                    this.updateStateVarsOfChildByElmtId(elmtId, {});
                }
            }, { name: "ToggleCommponent" });
        }
        __Common__.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            __Common__.create();
            __Common__.width('20%');
        }, __Common__);
        {
            this.observeComponentCreation2((elmtId, isInitialRender) => {
                if (isInitialRender) {
                    let paramsLambda = () => {
                        return {
                            title: '静音',
                            mListener: this.mMuteToggleListener
                        };
                    };
                    ViewPU.create(new ToggleCommponent(this, { title: '静音', mListener: this.mMuteToggleListener }, undefined, elmtId, paramsLambda, { page: "amdemos-player-ohos-listapp/src/main/ets/pages/PlayerPage.ets", line: 519 }));
                }
                else {
                    this.updateStateVarsOfChildByElmtId(elmtId, {});
                }
            }, { name: "ToggleCommponent" });
        }
        __Common__.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            __Common__.create();
            __Common__.width('20%');
        }, __Common__);
        {
            this.observeComponentCreation2((elmtId, isInitialRender) => {
                if (isInitialRender) {
                    let paramsLambda = () => {
                        return {
                            title: '循环',
                            mListener: this.mLoopToggleListener
                        };
                    };
                    ViewPU.create(new ToggleCommponent(this, { title: '循环', mListener: this.mLoopToggleListener }, undefined, elmtId, paramsLambda, { page: "amdemos-player-ohos-listapp/src/main/ets/pages/PlayerPage.ets", line: 520 }));
                }
                else {
                    this.updateStateVarsOfChildByElmtId(elmtId, {});
                }
            }, { name: "ToggleCommponent" });
        }
        __Common__.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            __Common__.create();
            __Common__.width('20%');
        }, __Common__);
        {
            this.observeComponentCreation2((elmtId, isInitialRender) => {
                if (isInitialRender) {
                    let paramsLambda = () => {
                        return {
                            title: '硬解',
                            mListener: this.mHardwareDecodeToggleListener,
                            lockState: this.hardwareDecodedEnableLocked && !this.switchedToSoft
                        };
                    };
                    ViewPU.create(new ToggleCommponent(this, {
                        title: '硬解',
                        mListener: this.mHardwareDecodeToggleListener,
                        lockState: this.hardwareDecodedEnableLocked && !this.switchedToSoft,
                    }, undefined, elmtId, paramsLambda, { page: "amdemos-player-ohos-listapp/src/main/ets/pages/PlayerPage.ets", line: 521 }));
                }
                else {
                    this.updateStateVarsOfChildByElmtId(elmtId, {
                        lockState: this.hardwareDecodedEnableLocked && !this.switchedToSoft
                    });
                }
            }, { name: "ToggleCommponent" });
        }
        __Common__.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            __Common__.create();
            __Common__.width('20%');
        }, __Common__);
        {
            this.observeComponentCreation2((elmtId, isInitialRender) => {
                if (isInitialRender) {
                    let paramsLambda = () => {
                        return {
                            title: '精准seek',
                            mListener: this.mAccurateSeekToggleListener
                        };
                    };
                    ViewPU.create(new ToggleCommponent(this, { title: '精准seek', mListener: this.mAccurateSeekToggleListener }, undefined, elmtId, paramsLambda, { page: "amdemos-player-ohos-listapp/src/main/ets/pages/PlayerPage.ets", line: 526 }));
                }
                else {
                    this.updateStateVarsOfChildByElmtId(elmtId, {});
                }
            }, { name: "ToggleCommponent" });
        }
        __Common__.pop();
        Row.pop();
    }
    /**
     * 音量条组建
     */
    VolumeSlider(parent = null) {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Row.create();
            Row.width('100%');
            Row.margin({ top: 10 });
            Row.height(40);
        }, Row);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Text.create('音量');
            Text.fontColor(0x333333);
            Text.width('20%');
            Text.textAlign(TextAlign.Center);
        }, Text);
        Text.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Slider.create({ style: SliderStyle.OutSet, value: this.volume });
            Slider.blockStyle({ type: SliderBlockType.DEFAULT });
            Slider.blockColor(0xff0000);
            Slider.trackColor(0xbbbbbb);
            Slider.selectedColor(0xff0000);
            Slider.width('80%');
            Slider.onChange((value: number) => {
                this.volume = value;
                VideoController.getPlayer(this.playerIndex)?.setVolume(value / 50);
                AppStorage.setOrCreate<number>(LOCAL_PROP_KEY_VOLUME, value);
                log.d(`volume: ${value} -> setVolume: ${value / 50}`);
            });
        }, Slider);
        Row.pop();
    }
    /**
     * 选择模式
     */
    SelectMode(parent = null) {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            __Common__.create();
            __Common__.margin({ top: 10, right: 10 });
        }, __Common__);
        {
            this.observeComponentCreation2((elmtId, isInitialRender) => {
                if (isInitialRender) {
                    let paramsLambda = () => {
                        return {
                            mTitle: '缩放模式',
                            mSelectTextArray: ['比例填充', '比例全屏', '拉伸全屏'],
                            mListener: this.mScaleModePlayBack
                        };
                    };
                    ViewPU.create(new SelectComponent(this, {
                        mTitle: '缩放模式',
                        mSelectTextArray: ['比例填充', '比例全屏', '拉伸全屏'],
                        mListener: this.mScaleModePlayBack,
                    }, undefined, elmtId, paramsLambda, { page: "amdemos-player-ohos-listapp/src/main/ets/pages/PlayerPage.ets", line: 557 }));
                }
                else {
                    this.updateStateVarsOfChildByElmtId(elmtId, {});
                }
            }, { name: "SelectComponent" });
        }
        __Common__.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            __Common__.create();
            __Common__.margin({ top: 10, right: 10 });
        }, __Common__);
        {
            this.observeComponentCreation2((elmtId, isInitialRender) => {
                if (isInitialRender) {
                    let paramsLambda = () => {
                        return {
                            mTitle: '镜像模式',
                            mSelectTextArray: ['无镜像', '水平镜像', '垂直镜像'],
                            mListener: this.mMirrorModePlayBack
                        };
                    };
                    ViewPU.create(new SelectComponent(this, {
                        mTitle: '镜像模式',
                        mSelectTextArray: ['无镜像', '水平镜像', '垂直镜像'],
                        mListener: this.mMirrorModePlayBack,
                    }, undefined, elmtId, paramsLambda, { page: "amdemos-player-ohos-listapp/src/main/ets/pages/PlayerPage.ets", line: 563 }));
                }
                else {
                    this.updateStateVarsOfChildByElmtId(elmtId, {});
                }
            }, { name: "SelectComponent" });
        }
        __Common__.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            __Common__.create();
            __Common__.margin({ top: 10, right: 10 });
        }, __Common__);
        {
            this.observeComponentCreation2((elmtId, isInitialRender) => {
                if (isInitialRender) {
                    let paramsLambda = () => {
                        return {
                            mTitle: '旋转模式',
                            mSelectTextArray: ['0°', '90°', '180°', '270°'],
                            mListener: this.mRotateModePlayBack
                        };
                    };
                    ViewPU.create(new SelectComponent(this, {
                        mTitle: '旋转模式',
                        mSelectTextArray: ['0°', '90°', '180°', '270°'],
                        mListener: this.mRotateModePlayBack,
                    }, undefined, elmtId, paramsLambda, { page: "amdemos-player-ohos-listapp/src/main/ets/pages/PlayerPage.ets", line: 569 }));
                }
                else {
                    this.updateStateVarsOfChildByElmtId(elmtId, {});
                }
            }, { name: "SelectComponent" });
        }
        __Common__.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            __Common__.create();
            __Common__.margin({ top: 10, right: 10 });
        }, __Common__);
        {
            this.observeComponentCreation2((elmtId, isInitialRender) => {
                if (isInitialRender) {
                    let paramsLambda = () => {
                        return {
                            mTitle: '倍速播放',
                            mSelectTextArray: ['正常', '0.5', '1.5', '2.0', '5.0'],
                            mListener: this.mMultiplyPlayback
                        };
                    };
                    ViewPU.create(new SelectComponent(this, {
                        mTitle: '倍速播放',
                        mSelectTextArray: ['正常', '0.5', '1.5', '2.0', '5.0'],
                        mListener: this.mMultiplyPlayback
                    }, undefined, elmtId, paramsLambda, { page: "amdemos-player-ohos-listapp/src/main/ets/pages/PlayerPage.ets", line: 575 }));
                }
                else {
                    this.updateStateVarsOfChildByElmtId(elmtId, {});
                }
            }, { name: "SelectComponent" });
        }
        __Common__.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            __Common__.create();
            __Common__.margin({ top: 10, right: 10 });
        }, __Common__);
        {
            this.observeComponentCreation2((elmtId, isInitialRender) => {
                if (isInitialRender) {
                    let paramsLambda = () => {
                        return {
                            mTitle: '声道切换',
                            mSelectTextArray: ['NONE', 'LEFT', 'RIGHT']
                        };
                    };
                    ViewPU.create(new SelectComponent(this, { mTitle: '声道切换', mSelectTextArray: ['NONE', 'LEFT', 'RIGHT'] }, undefined, elmtId, paramsLambda, { page: "amdemos-player-ohos-listapp/src/main/ets/pages/PlayerPage.ets", line: 581 }));
                }
                else {
                    this.updateStateVarsOfChildByElmtId(elmtId, {});
                }
            }, { name: "SelectComponent" });
        }
        __Common__.pop();
    }
    BackgroundColor(parent = null) {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Row.create();
            Row.width('100%');
            Row.margin({ top: 10 });
            Row.height(34);
        }, Row);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Text.create('背景色');
            Text.fontColor(0x333333);
            Text.width('20%');
            Text.textAlign(TextAlign.Center);
        }, Text);
        Text.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            TextInput.create({ text: this.mBackgroundColor });
            TextInput.showUnderline(true);
            TextInput.width('60%');
            TextInput.caretColor(0xff0000);
            TextInput.onChange((value: string) => {
                this.mBackgroundColor = value;
            });
            TextInput.onBlur(() => {
                try {
                    if (this.mBackgroundColor.startsWith('#')) {
                        const parsedColor = Number('0x' + this.mBackgroundColor.slice(1));
                        VideoController.getPlayer(this.playerIndex)?.setVideoBackgroundColor(parsedColor);
                        showToast("Color: " + parsedColor);
                    }
                    else {
                        showToast('颜色解析失败：#开头 ARGB');
                    }
                }
                catch (e) {
                    showToast('颜色解析失败：#开头 ARGB');
                }
            });
        }, TextInput);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Text.create('确定');
            Text.fontColor({ "id": 16777223, "type": 10001, params: [], "bundleName": "com.aliyun.player.ohos_demo", "moduleName": "listapp" });
            Text.width('20%');
            Text.textAlign(TextAlign.Center);
        }, Text);
        Text.pop();
        Row.pop();
    }
    BitBandWidth(parent = null) {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Row.create();
            Row.width('100%');
            Row.margin({ top: 10 });
            Row.height(34);
        }, Row);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Text.create('多码率默认带宽');
            Text.fontColor(0x333333);
            Text.width('20%');
            Text.textAlign(TextAlign.Center);
        }, Text);
        Text.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            TextInput.create({ placeholder: 'b/s', text: this.mBitBandWidth });
            TextInput.showUnderline(true);
            TextInput.width('60%');
            TextInput.caretColor(0xff0000);
            TextInput.onChange((value: string) => {
                this.mBitBandWidth = value;
            });
        }, TextInput);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Text.create('确定');
            Text.fontColor({ "id": 16777223, "type": 10001, params: [], "bundleName": "com.aliyun.player.ohos_demo", "moduleName": "listapp" });
            Text.width('20%');
            Text.textAlign(TextAlign.Center);
        }, Text);
        Text.pop();
        Row.pop();
    }
    rerender() {
        this.updateDirtyElements();
    }
}
class PlayerConfigTabComponent extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1, paramsLambda = undefined, extraInfo) {
        super(parent, __localStorage, elmtId, extraInfo);
        if (typeof paramsLambda === "function") {
            this.paramsGenerator_ = paramsLambda;
        }
        this.__playerIndex = new SynchedPropertySimpleOneWayPU(params.playerIndex, this, "playerIndex");
        this.scroller = new Scroller();
        this.mPlayerConfig = new PlayerConfig();
        this.mVideoTunnelRenderListener = {
            onToggleChange: (isOn: boolean) => {
                console.log("[HOS DEMO]: PLAYERPAGE", "toggle videoTunnelRender", isOn);
                showToast("videoTunnelRender " + isOn + " " + this.playerIndex);
                this.mPlayerConfig.mEnableVideoTunnelRender = isOn;
                VideoController.getPlayer(this.playerIndex)?.setConfig(this.mPlayerConfig);
            }
        };
        this.setInitiallyProvidedValue(params);
    }
    setInitiallyProvidedValue(params: PlayerConfigTabComponent_Params) {
        if (params.playerIndex === undefined) {
            this.__playerIndex.set(-1);
        }
        if (params.scroller !== undefined) {
            this.scroller = params.scroller;
        }
        if (params.mPlayerConfig !== undefined) {
            this.mPlayerConfig = params.mPlayerConfig;
        }
        if (params.mVideoTunnelRenderListener !== undefined) {
            this.mVideoTunnelRenderListener = params.mVideoTunnelRenderListener;
        }
    }
    updateStateVars(params: PlayerConfigTabComponent_Params) {
        this.__playerIndex.reset(params.playerIndex);
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
        this.__playerIndex.purgeDependencyOnElmtId(rmElmtId);
    }
    aboutToBeDeleted() {
        this.__playerIndex.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    private __playerIndex: SynchedPropertySimpleOneWayPU<number>;
    get playerIndex() {
        return this.__playerIndex.get();
    }
    set playerIndex(newValue: number) {
        this.__playerIndex.set(newValue);
    }
    private scroller: Scroller;
    private mPlayerConfig: PlayerConfig;
    private mVideoTunnelRenderListener: OnToggleListener;
    initialRender() {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Scroll.create(this.scroller);
            Scroll.height('100%');
            Scroll.scrollable(ScrollDirection.Vertical);
            Scroll.friction(0.6);
            Scroll.edgeEffect(EdgeEffect.None);
        }, Scroll);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Column.create();
            Column.alignItems(HorizontalAlign.Start);
            Column.padding({ bottom: 25 });
        }, Column);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            __Common__.create();
            __Common__.width('20%');
            __Common__.margin({ top: 10 });
            __Common__.height(34);
        }, __Common__);
        {
            this.observeComponentCreation2((elmtId, isInitialRender) => {
                if (isInitialRender) {
                    let paramsLambda = () => {
                        return {
                            title: 'EnableVideoTunnelRender',
                            mListener: this.mVideoTunnelRenderListener
                        };
                    };
                    ViewPU.create(new ToggleCommponent(this, { title: 'EnableVideoTunnelRender', mListener: this.mVideoTunnelRenderListener }, undefined, elmtId, paramsLambda, { page: "amdemos-player-ohos-listapp/src/main/ets/pages/PlayerPage.ets", line: 647 }));
                }
                else {
                    this.updateStateVarsOfChildByElmtId(elmtId, {});
                }
            }, { name: "ToggleCommponent" });
        }
        __Common__.pop();
        Column.pop();
        Scroll.pop();
    }
    rerender() {
        this.updateDirtyElements();
    }
}
class UrlDialogComponent extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1, paramsLambda = undefined, extraInfo) {
        super(parent, __localStorage, elmtId, extraInfo);
        if (typeof paramsLambda === "function") {
            this.paramsGenerator_ = paramsLambda;
        }
        this.mController = undefined;
        this.setInitiallyProvidedValue(params);
    }
    setInitiallyProvidedValue(params: UrlDialogComponent_Params) {
        if (params.mController !== undefined) {
            this.mController = params.mController;
        }
    }
    updateStateVars(params: UrlDialogComponent_Params) {
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
    }
    aboutToBeDeleted() {
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    private mController?: CustomDialogController;
    setController(ctr: CustomDialogController) {
        this.mController = ctr;
    }
    private onDialogClick(index: number) {
        log.i('onDialogClick: ' + index);
        switch (index) {
            case 0: // 对话框点击清空列表
                break;
            case 1: // 添加列表
                break;
            default:
                break;
        }
    }
    initialRender() {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Column.create();
            Column.width('100%');
        }, Column);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Blank.create();
            Blank.width('100%');
            Blank.height(250);
        }, Blank);
        Blank.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Row.create();
            Row.width('100%');
        }, Row);
        this.DialogButton.bind(this)('清空列表', 0);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Blank.create();
        }, Blank);
        Blank.pop();
        this.DialogButton.bind(this)('添加列表', 1);
        Row.pop();
        Column.pop();
    }
    DialogButton(title: string, index: number, parent = null) {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Button.createWithLabel(title, { type: ButtonType.Normal, stateEffect: true });
            Button.fontColor(0x333333);
            Button.fontSize(12);
            Button.backgroundColor(0xCCCCCC);
            Button.borderRadius(2);
            Button.margin({ left: 10, right: 10, bottom: 10 });
            Button.onClick(() => {
                this.onDialogClick(index);
            });
        }, Button);
        Button.pop();
    }
    rerender() {
        this.updateDirtyElements();
    }
}
interface OnToggleListener {
    onToggleChange: (isOn: boolean) => void;
}
export interface OnFullscreenToggleListener {
    onFullscreenToggled: () => void;
}
export interface OnSwitchedToSoftListener {
    onSwitched: () => void;
}
interface OnButtonCLicked {
    onClick: (type: number) => void;
}
registerNamedRoute(() => new PlayerPage(undefined, {}), "", { bundleName: "com.aliyun.player.ohos_demo", moduleName: "listapp", pagePath: "pages/PlayerPage" });
