interface SettingsPage_Params {
    enableHardwareDecode?: boolean;
    enableHDR?: boolean;
    enableSwitchingSTS?: boolean;
    enableFilter?: boolean;
    enableHTTP2?: boolean;
    enableHTTP3?: boolean;
    enableHTTPDNS?: boolean;
    enableLocalLogFiles?: boolean;
    toggles?: toggleItem[];
}
import { HeaderComponent } from "@bundle:com.aliyun.player.ohos_demo/listapp/ets/view/HeaderComponent";
import { ToggleComponent } from "@bundle:com.aliyun.player.ohos_demo/listapp/ets/view/RowToggleComponent";
import { AliPlayerGlobalSettings } from "@package:pkg_modules/.ohpm/premierlibrary@donfdoen1mcr6ssy+rjg6ltkuce=/pkg_modules/premierlibrary/Index";
import { LOCAL_PROP_KEY_HARDWARE_DECODE_ENABLED, LOCAL_PROP_KEY_HTTP2_ENABLED } from "@bundle:com.aliyun.player.ohos_demo/listapp/ets/common/Constants";
import { showToast } from "@bundle:com.aliyun.player.ohos_demo/listapp/ets/common/util/CommonUtils";
class SettingsPage extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1, paramsLambda = undefined, extraInfo) {
        super(parent, __localStorage, elmtId, extraInfo);
        if (typeof paramsLambda === "function") {
            this.paramsGenerator_ = paramsLambda;
        }
        this.__enableHardwareDecode = this.createStorageProp(LOCAL_PROP_KEY_HARDWARE_DECODE_ENABLED, true, "enableHardwareDecode");
        this.__enableHDR = new ObservedPropertySimplePU(false, this, "enableHDR");
        this.__enableSwitchingSTS = new ObservedPropertySimplePU(false, this, "enableSwitchingSTS");
        this.__enableFilter = new ObservedPropertySimplePU(false, this, "enableFilter");
        this.__enableHTTP2 = this.createStorageProp(LOCAL_PROP_KEY_HTTP2_ENABLED, false, "enableHTTP2");
        this.__enableHTTP3 = new ObservedPropertySimplePU(false, this, "enableHTTP3");
        this.__enableHTTPDNS = new ObservedPropertySimplePU(false, this, "enableHTTPDNS");
        this.__enableLocalLogFiles = new ObservedPropertySimplePU(false, this, "enableLocalLogFiles");
        this.toggles = [
            new toggleItem('硬解', 20, this.enableHardwareDecode, (isOn: boolean) => {
                showToast("hard" + isOn);
                AppStorage.setOrCreate<boolean>(LOCAL_PROP_KEY_HARDWARE_DECODE_ENABLED, isOn);
            }),
            new toggleItem('HDR', 20, this.enableHDR, (isOn: boolean) => {
            }),
            new toggleItem('切换STS', 20, this.enableSwitchingSTS, (isOn: boolean) => {
            }),
            new toggleItem('Filter', 20, this.enableFilter, (isOn: boolean) => {
            }),
            new toggleItem('http2', 20, this.enableHTTP2, (isOn: boolean) => {
                showToast('http2 ' + isOn);
                AppStorage.setOrCreate<boolean>(LOCAL_PROP_KEY_HTTP2_ENABLED, isOn);
                AliPlayerGlobalSettings.setUseHttp2(isOn);
                console.log("HOS DEMO", "Http2 ", isOn);
            }),
            new toggleItem('http3', 20, this.enableHTTP3, (isOn: boolean) => {
            }),
            new toggleItem('enableHttpDns', 20, this.enableHTTPDNS, (isOn: boolean) => {
            }),
            new toggleItem('本地日志', 20, this.enableLocalLogFiles, (isOn: boolean) => {
            }),
        ];
        this.setInitiallyProvidedValue(params);
    }
    setInitiallyProvidedValue(params: SettingsPage_Params) {
        if (params.enableHDR !== undefined) {
            this.enableHDR = params.enableHDR;
        }
        if (params.enableSwitchingSTS !== undefined) {
            this.enableSwitchingSTS = params.enableSwitchingSTS;
        }
        if (params.enableFilter !== undefined) {
            this.enableFilter = params.enableFilter;
        }
        if (params.enableHTTP3 !== undefined) {
            this.enableHTTP3 = params.enableHTTP3;
        }
        if (params.enableHTTPDNS !== undefined) {
            this.enableHTTPDNS = params.enableHTTPDNS;
        }
        if (params.enableLocalLogFiles !== undefined) {
            this.enableLocalLogFiles = params.enableLocalLogFiles;
        }
        if (params.toggles !== undefined) {
            this.toggles = params.toggles;
        }
    }
    updateStateVars(params: SettingsPage_Params) {
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
        this.__enableHardwareDecode.purgeDependencyOnElmtId(rmElmtId);
        this.__enableHDR.purgeDependencyOnElmtId(rmElmtId);
        this.__enableSwitchingSTS.purgeDependencyOnElmtId(rmElmtId);
        this.__enableFilter.purgeDependencyOnElmtId(rmElmtId);
        this.__enableHTTP2.purgeDependencyOnElmtId(rmElmtId);
        this.__enableHTTP3.purgeDependencyOnElmtId(rmElmtId);
        this.__enableHTTPDNS.purgeDependencyOnElmtId(rmElmtId);
        this.__enableLocalLogFiles.purgeDependencyOnElmtId(rmElmtId);
    }
    aboutToBeDeleted() {
        this.__enableHardwareDecode.aboutToBeDeleted();
        this.__enableHDR.aboutToBeDeleted();
        this.__enableSwitchingSTS.aboutToBeDeleted();
        this.__enableFilter.aboutToBeDeleted();
        this.__enableHTTP2.aboutToBeDeleted();
        this.__enableHTTP3.aboutToBeDeleted();
        this.__enableHTTPDNS.aboutToBeDeleted();
        this.__enableLocalLogFiles.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    private __enableHardwareDecode: ObservedPropertyAbstractPU<boolean>;
    get enableHardwareDecode() {
        return this.__enableHardwareDecode.get();
    }
    set enableHardwareDecode(newValue: boolean) {
        this.__enableHardwareDecode.set(newValue);
    }
    private __enableHDR: ObservedPropertySimplePU<boolean>;
    get enableHDR() {
        return this.__enableHDR.get();
    }
    set enableHDR(newValue: boolean) {
        this.__enableHDR.set(newValue);
    }
    private __enableSwitchingSTS: ObservedPropertySimplePU<boolean>;
    get enableSwitchingSTS() {
        return this.__enableSwitchingSTS.get();
    }
    set enableSwitchingSTS(newValue: boolean) {
        this.__enableSwitchingSTS.set(newValue);
    }
    private __enableFilter: ObservedPropertySimplePU<boolean>;
    get enableFilter() {
        return this.__enableFilter.get();
    }
    set enableFilter(newValue: boolean) {
        this.__enableFilter.set(newValue);
    }
    private __enableHTTP2: ObservedPropertyAbstractPU<boolean>;
    get enableHTTP2() {
        return this.__enableHTTP2.get();
    }
    set enableHTTP2(newValue: boolean) {
        this.__enableHTTP2.set(newValue);
    }
    private __enableHTTP3: ObservedPropertySimplePU<boolean>;
    get enableHTTP3() {
        return this.__enableHTTP3.get();
    }
    set enableHTTP3(newValue: boolean) {
        this.__enableHTTP3.set(newValue);
    }
    private __enableHTTPDNS: ObservedPropertySimplePU<boolean>;
    get enableHTTPDNS() {
        return this.__enableHTTPDNS.get();
    }
    set enableHTTPDNS(newValue: boolean) {
        this.__enableHTTPDNS.set(newValue);
    }
    private __enableLocalLogFiles: ObservedPropertySimplePU<boolean>;
    get enableLocalLogFiles() {
        return this.__enableLocalLogFiles.get();
    }
    set enableLocalLogFiles(newValue: boolean) {
        this.__enableLocalLogFiles.set(newValue);
    }
    private toggles: toggleItem[];
    initialRender() {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Row.create();
            Row.height('100%');
            Row.alignItems(VerticalAlign.Top);
        }, Row);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Column.create();
            Column.width('100%');
            Column.alignItems(HorizontalAlign.Start);
        }, Column);
        {
            this.observeComponentCreation2((elmtId, isInitialRender) => {
                if (isInitialRender) {
                    let paramsLambda = () => {
                        return {
                            title: '设置'
                        };
                    };
                    ViewPU.create(new HeaderComponent(this, { title: '设置' }, undefined, elmtId, paramsLambda, { page: "amdemos-player-ohos-listapp/src/main/ets/pages/SettingsPage.ets", line: 55 }));
                }
                else {
                    this.updateStateVarsOfChildByElmtId(elmtId, {});
                }
            }, { name: "HeaderComponent" });
        }
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Text.create('版本号: xxx');
            Text.fontSize(20);
            Text.fontColor(0xbbbbbb);
            Text.margin(20);
        }, Text);
        Text.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            // support info
            ForEach.create();
            const forEachItemGenFunction = _item => {
                const item = _item;
                this.observeComponentCreation2((elmtId, isInitialRender) => {
                    __Common__.create();
                    __Common__.margin({ left: 20, top: 4 });
                }, __Common__);
                {
                    this.observeComponentCreation2((elmtId, isInitialRender) => {
                        if (isInitialRender) {
                            let paramsLambda = () => {
                                return {
                                    mTitle: item.mTitle,
                                    textSize: item.textSize,
                                    status: item.status,
                                    mOnToggleChangeHandler: { onChange: item.handler }
                                };
                            };
                            ViewPU.create(new ToggleComponent(this, {
                                mTitle: item.mTitle,
                                textSize: item.textSize,
                                status: item.status,
                                mOnToggleChangeHandler: { onChange: item.handler }
                            }, undefined, elmtId, paramsLambda, { page: "amdemos-player-ohos-listapp/src/main/ets/pages/SettingsPage.ets", line: 59 }));
                        }
                        else {
                            this.updateStateVarsOfChildByElmtId(elmtId, {
                                mOnToggleChangeHandler: { onChange: item.handler }
                            });
                        }
                    }, { name: "ToggleComponent" });
                }
                __Common__.pop();
            };
            this.forEachUpdateFunction(elmtId, this.toggles, forEachItemGenFunction);
        }, ForEach);
        // support info
        ForEach.pop();
        Column.pop();
        Row.pop();
    }
    rerender() {
        this.updateDirtyElements();
    }
    static getEntryName(): string {
        return "SettingsPage";
    }
}
class toggleItem {
    mTitle: string = '';
    textSize: number = 12;
    status: boolean = false;
    handler: (isOn: boolean) => void = () => { };
    constructor(mTitle: string, textSize: number, status: boolean, handler: (isOn: boolean) => void) {
        this.mTitle = mTitle;
        this.textSize = textSize;
        this.status = status;
        this.handler = handler;
    }
}
registerNamedRoute(() => new SettingsPage(undefined, {}), "", { bundleName: "com.aliyun.player.ohos_demo", moduleName: "listapp", pagePath: "pages/SettingsPage" });
