interface SwiperPage_Params {
    videoList?: Array<string>;
    isFullScreen?: boolean;
    showFinishScene?: boolean;
    showLoadingScene?: boolean;
    seekType?: SEEK_TYPE;
    index?: number;
    swiperController?: SwiperController;
    playerInstancesIndex?: Array<number>;
}
import router from "@ohos:router";
import { H264VideoUrls, SEEK_TYPE } from "@bundle:com.aliyun.player.ohos_demo/listapp/ets/common/Constants";
import { VideoComponent } from "@bundle:com.aliyun.player.ohos_demo/listapp/ets/view/VideoComponent";
import VideoController from "@bundle:com.aliyun.player.ohos_demo/listapp/ets/controller/VideoController";
import { showToast } from "@bundle:com.aliyun.player.ohos_demo/listapp/ets/common/util/CommonUtils";
class SwiperPage extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1, paramsLambda = undefined, extraInfo) {
        super(parent, __localStorage, elmtId, extraInfo);
        if (typeof paramsLambda === "function") {
            this.paramsGenerator_ = paramsLambda;
        }
        this.videoList = [];
        this.__isFullScreen = new ObservedPropertySimplePU(false, this, "isFullScreen");
        this.__showFinishScene = new ObservedPropertySimplePU(false, this, "showFinishScene");
        this.__showLoadingScene = new ObservedPropertySimplePU(false, this, "showLoadingScene");
        this.__seekType = new ObservedPropertySimplePU(SEEK_TYPE.NORMAL, this, "seekType");
        this.index = 0;
        this.swiperController = new SwiperController();
        this.__playerInstancesIndex = new ObservedPropertyObjectPU([], this, "playerInstancesIndex");
        this.setInitiallyProvidedValue(params);
    }
    setInitiallyProvidedValue(params: SwiperPage_Params) {
        if (params.videoList !== undefined) {
            this.videoList = params.videoList;
        }
        if (params.isFullScreen !== undefined) {
            this.isFullScreen = params.isFullScreen;
        }
        if (params.showFinishScene !== undefined) {
            this.showFinishScene = params.showFinishScene;
        }
        if (params.showLoadingScene !== undefined) {
            this.showLoadingScene = params.showLoadingScene;
        }
        if (params.seekType !== undefined) {
            this.seekType = params.seekType;
        }
        if (params.index !== undefined) {
            this.index = params.index;
        }
        if (params.swiperController !== undefined) {
            this.swiperController = params.swiperController;
        }
        if (params.playerInstancesIndex !== undefined) {
            this.playerInstancesIndex = params.playerInstancesIndex;
        }
    }
    updateStateVars(params: SwiperPage_Params) {
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
        this.__isFullScreen.purgeDependencyOnElmtId(rmElmtId);
        this.__showFinishScene.purgeDependencyOnElmtId(rmElmtId);
        this.__showLoadingScene.purgeDependencyOnElmtId(rmElmtId);
        this.__seekType.purgeDependencyOnElmtId(rmElmtId);
        this.__playerInstancesIndex.purgeDependencyOnElmtId(rmElmtId);
    }
    aboutToBeDeleted() {
        this.__isFullScreen.aboutToBeDeleted();
        this.__showFinishScene.aboutToBeDeleted();
        this.__showLoadingScene.aboutToBeDeleted();
        this.__seekType.aboutToBeDeleted();
        this.__playerInstancesIndex.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    private videoList: Array<string>;
    private __isFullScreen: ObservedPropertySimplePU<boolean>;
    get isFullScreen() {
        return this.__isFullScreen.get();
    }
    set isFullScreen(newValue: boolean) {
        this.__isFullScreen.set(newValue);
    }
    private __showFinishScene: ObservedPropertySimplePU<boolean>;
    get showFinishScene() {
        return this.__showFinishScene.get();
    }
    set showFinishScene(newValue: boolean) {
        this.__showFinishScene.set(newValue);
    }
    private __showLoadingScene: ObservedPropertySimplePU<boolean>;
    get showLoadingScene() {
        return this.__showLoadingScene.get();
    }
    set showLoadingScene(newValue: boolean) {
        this.__showLoadingScene.set(newValue);
    }
    private __seekType: ObservedPropertySimplePU<SEEK_TYPE>;
    get seekType() {
        return this.__seekType.get();
    }
    set seekType(newValue: SEEK_TYPE) {
        this.__seekType.set(newValue);
    }
    private index: number;
    private swiperController: SwiperController;
    private __playerInstancesIndex: ObservedPropertyObjectPU<Array<number>>;
    get playerInstancesIndex() {
        return this.__playerInstancesIndex.get();
    }
    set playerInstancesIndex(newValue: Array<number>) {
        this.__playerInstancesIndex.set(newValue);
    }
    initialRender() {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Row.create();
            Row.width('100%');
            Row.height('100%');
            Row.alignItems(VerticalAlign.Top);
        }, Row);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Column.create();
            Column.width('100%');
            Column.height('100%');
            Column.alignItems(HorizontalAlign.Center);
            Column.justifyContent(FlexAlign.Center);
        }, Column);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Swiper.create(this.swiperController);
            Swiper.cachedCount(1);
            Swiper.index(0);
            Swiper.vertical(true);
            Swiper.indicator(true);
            Swiper.loop(true);
            Swiper.duration(1000);
            Swiper.itemSpace(0);
            Swiper.curve(Curve.Linear);
            Swiper.onChange((newIndex: number) => {
                // console.info(index.toString())
                showToast(newIndex.toString());
                // current index dispose
                VideoController.getPlayer(this.playerInstancesIndex[this.index])?.stop();
                // VideoController.dispose(this.playerInstancesIndex[this.index]);
                // new index setautoplay prepare
                VideoController.getPlayer(this.playerInstancesIndex[newIndex])?.setAutoPlay(true);
                VideoController.getPlayer(this.playerInstancesIndex[newIndex])?.prepare();
                // current index = new index
                this.index = newIndex;
            });
        }, Swiper);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            ForEach.create();
            const forEachItemGenFunction = (_item, index: number) => {
                const item = _item;
                this.observeComponentCreation2((elmtId, isInitialRender) => {
                    // Text(item).width('90%').height(160).backgroundColor(0xAFEEEE).textAlign(TextAlign.Center).fontSize(30)
                    Column.create();
                    // Text(item).width('90%').height(160).backgroundColor(0xAFEEEE).textAlign(TextAlign.Center).fontSize(30)
                    Column.width('100%');
                    // Text(item).width('90%').height(160).backgroundColor(0xAFEEEE).textAlign(TextAlign.Center).fontSize(30)
                    Column.height('100%');
                    // Text(item).width('90%').height(160).backgroundColor(0xAFEEEE).textAlign(TextAlign.Center).fontSize(30)
                    Column.justifyContent(FlexAlign.Center);
                    // Text(item).width('90%').height(160).backgroundColor(0xAFEEEE).textAlign(TextAlign.Center).fontSize(30)
                    Column.alignItems(HorizontalAlign.Center);
                }, Column);
                {
                    this.observeComponentCreation2((elmtId, isInitialRender) => {
                        if (isInitialRender) {
                            let paramsLambda = () => {
                                return {
                                    videoUrl: item,
                                    playerIndex: this.playerInstancesIndex[index],
                                    _forceHeight: 3740,
                                    seekType: this.seekType,
                                    isFullScreen: this.isFullScreen,
                                    showFinishScene: this.showFinishScene,
                                    showLoadingScene: this.showLoadingScene
                                };
                            };
                            ViewPU.create(new VideoComponent(this, {
                                videoUrl: item,
                                playerIndex: this.playerInstancesIndex[index],
                                _forceHeight: 3740,
                                seekType: this.__seekType,
                                isFullScreen: this.__isFullScreen,
                                showFinishScene: this.__showFinishScene,
                                showLoadingScene: this.__showLoadingScene
                            }, undefined, elmtId, paramsLambda, { page: "amdemos-player-ohos-listapp/src/main/ets/pages/SwiperPage.ets", line: 27 }));
                        }
                        else {
                            this.updateStateVarsOfChildByElmtId(elmtId, {
                                playerIndex: this.playerInstancesIndex[index],
                                _forceHeight: 3740
                            });
                        }
                    }, { name: "VideoComponent" });
                }
                // Text(item).width('90%').height(160).backgroundColor(0xAFEEEE).textAlign(TextAlign.Center).fontSize(30)
                Column.pop();
            };
            this.forEachUpdateFunction(elmtId, this.videoList, forEachItemGenFunction, undefined, true, false);
        }, ForEach);
        ForEach.pop();
        Swiper.pop();
        Column.pop();
        Row.pop();
    }
    aboutToAppear() {
        let params: object = router.getParams();
        // this.videoList = params['videoList'];
        this.videoList = H264VideoUrls.slice(0, 6);
        for (let i = 0; i < this.videoList.length; i++) {
            this.playerInstancesIndex[i] = VideoController.createAliPlayer(getContext(), null);
        }
        showToast(this.videoList.length.toString());
        VideoController.getPlayer(this.playerInstancesIndex[this.index])?.setAutoPlay(true);
        VideoController.getPlayer(this.playerInstancesIndex[this.index])?.prepare();
    }
    rerender() {
        this.updateDirtyElements();
    }
    static getEntryName(): string {
        return "SwiperPage";
    }
}
registerNamedRoute(() => new SwiperPage(undefined, {}), "", { bundleName: "com.aliyun.player.ohos_demo", moduleName: "listapp", pagePath: "pages/SwiperPage" });
