interface UrlSelectItem_Params {
    url?: string;
    index?: number;
    mListener?: OnCheckboxSelected;
}
interface UrlSelectPage_Params {
    title?: string;
    codec?: string;
    format?: string;
    isMarked?: Array<boolean>;
    allVideoList?: Array<string>;
    mUrlSelectedListener?: OnCheckboxSelected;
    mGoToMultiPlayerListener?: onRightClickListener;
}
import { HeaderComponent } from "@bundle:com.aliyun.player.ohos_demo/listapp/ets/view/HeaderComponent";
import type { onRightClickListener } from "@bundle:com.aliyun.player.ohos_demo/listapp/ets/view/HeaderComponent";
import { H264VideoUrls, H265VideoUrls, H264Mp4Urls, H264HlsUrls, H264FlvUrls, H265Mp4Urls, H265HlsUrls, LiveStreamUrls } from "@bundle:com.aliyun.player.ohos_demo/listapp/ets/common/Constants";
import { showToast } from "@bundle:com.aliyun.player.ohos_demo/listapp/ets/common/util/CommonUtils";
import router from "@ohos:router";
class UrlSelectPage extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1, paramsLambda = undefined, extraInfo) {
        super(parent, __localStorage, elmtId, extraInfo);
        if (typeof paramsLambda === "function") {
            this.paramsGenerator_ = paramsLambda;
        }
        this.__title = new ObservedPropertySimplePU('选择URL', this, "title");
        this.__codec = new ObservedPropertySimplePU('H264', this, "codec");
        this.__format = new ObservedPropertySimplePU('mp4', this, "format");
        this.isMarked = [];
        this.allVideoList = [];
        this.mUrlSelectedListener = {
            onCheckboxChange: (selected: boolean, index: number) => {
                if (index < this.isMarked.length) {
                    this.isMarked[index] = selected;
                }
            }
        };
        this.mGoToMultiPlayerListener = {
            onRightItemClick: () => {
                let selectedList: Array<string> = [];
                for (let i = 0; i < this.isMarked.length; i++) {
                    if (this.isMarked[i]) {
                        selectedList.push(this.allVideoList[i]);
                    }
                }
                router.pushUrl({ url: 'pages/ListPlayerPage', params: { videoUrlList: selectedList } });
            }
        };
        this.setInitiallyProvidedValue(params);
    }
    setInitiallyProvidedValue(params: UrlSelectPage_Params) {
        if (params.title !== undefined) {
            this.title = params.title;
        }
        if (params.codec !== undefined) {
            this.codec = params.codec;
        }
        if (params.format !== undefined) {
            this.format = params.format;
        }
        if (params.isMarked !== undefined) {
            this.isMarked = params.isMarked;
        }
        if (params.allVideoList !== undefined) {
            this.allVideoList = params.allVideoList;
        }
        if (params.mUrlSelectedListener !== undefined) {
            this.mUrlSelectedListener = params.mUrlSelectedListener;
        }
        if (params.mGoToMultiPlayerListener !== undefined) {
            this.mGoToMultiPlayerListener = params.mGoToMultiPlayerListener;
        }
    }
    updateStateVars(params: UrlSelectPage_Params) {
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
        this.__title.purgeDependencyOnElmtId(rmElmtId);
        this.__codec.purgeDependencyOnElmtId(rmElmtId);
        this.__format.purgeDependencyOnElmtId(rmElmtId);
    }
    aboutToBeDeleted() {
        this.__title.aboutToBeDeleted();
        this.__codec.aboutToBeDeleted();
        this.__format.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    private __title: ObservedPropertySimplePU<string>;
    get title() {
        return this.__title.get();
    }
    set title(newValue: string) {
        this.__title.set(newValue);
    }
    private __codec: ObservedPropertySimplePU<string>;
    get codec() {
        return this.__codec.get();
    }
    set codec(newValue: string) {
        this.__codec.set(newValue);
    }
    private __format: ObservedPropertySimplePU<string>;
    get format() {
        return this.__format.get();
    }
    set format(newValue: string) {
        this.__format.set(newValue);
    }
    private isMarked: Array<boolean>;
    private allVideoList: Array<string>;
    private mUrlSelectedListener: OnCheckboxSelected;
    private mGoToMultiPlayerListener: onRightClickListener;
    aboutToAppear() {
        let params: object = router.getParams();
        this.title = params['title'];
        this.codec = params['codec'];
        this.format = params['format'];
        if (this.codec === 'H264' && this.format === 'mp4-long') {
            this.allVideoList = H264VideoUrls;
        }
        else if (this.codec === 'H265' && this.format === 'mp4-long') {
            this.allVideoList = H265VideoUrls;
        }
        else if (this.codec === 'H264' && this.format === 'mp4') {
            this.allVideoList = H264Mp4Urls;
        }
        else if (this.codec === 'H264' && this.format === 'hls') {
            this.allVideoList = H264HlsUrls;
        }
        else if (this.codec === 'H264' && this.format === 'flv') {
            this.allVideoList = H264FlvUrls;
        }
        else if (this.codec === 'H265' && this.format === 'mp4') {
            this.allVideoList = H265Mp4Urls;
        }
        else if (this.codec === 'H265' && this.format === 'hls') {
            this.allVideoList = H265HlsUrls;
        }
        else if (this.codec === 'LiveStream') {
            this.allVideoList = LiveStreamUrls;
        }
        let totalLen: number = this.allVideoList.length;
        showToast(totalLen.toString());
        this.isMarked = new Array(totalLen);
        this.isMarked.fill(false);
    }
    initialRender() {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Row.create();
            Row.height('100%');
            Row.alignItems(VerticalAlign.Top);
        }, Row);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Column.create();
            Column.width('100%');
        }, Column);
        {
            this.observeComponentCreation2((elmtId, isInitialRender) => {
                if (isInitialRender) {
                    let paramsLambda = () => {
                        return {
                            isSupportBackClick: true,
                            title: this.title,
                            rightTitle: "多实例播放",
                            rightListener: this.mGoToMultiPlayerListener
                        };
                    };
                    ViewPU.create(new HeaderComponent(this, { isSupportBackClick: true, title: this.title, rightTitle: "多实例播放", rightListener: this.mGoToMultiPlayerListener }, undefined, elmtId, paramsLambda, { page: "amdemos-player-ohos-listapp/src/main/ets/pages/UrlSelectPage.ets", line: 71 }));
                }
                else {
                    this.updateStateVarsOfChildByElmtId(elmtId, {});
                }
            }, { name: "HeaderComponent" });
        }
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            List.create({ space: 8, initialIndex: 0 });
            List.listDirection(Axis.Vertical);
            List.scrollBar(BarState.Off);
            List.friction(0.6);
            List.edgeEffect(EdgeEffect.Spring);
            List.width('98%');
            List.margin({ bottom: 20 });
        }, List);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            ForEach.create();
            const forEachItemGenFunction = (_item, index: number) => {
                const item = _item;
                {
                    const itemCreation = (elmtId, isInitialRender) => {
                        ViewStackProcessor.StartGetAccessRecordingFor(elmtId);
                        itemCreation2(elmtId, isInitialRender);
                        if (!isInitialRender) {
                            ListItem.pop();
                        }
                        ViewStackProcessor.StopGetAccessRecording();
                    };
                    const itemCreation2 = (elmtId, isInitialRender) => {
                        ListItem.create(deepRenderFunction, true);
                    };
                    const deepRenderFunction = (elmtId, isInitialRender) => {
                        itemCreation(elmtId, isInitialRender);
                        {
                            this.observeComponentCreation2((elmtId, isInitialRender) => {
                                if (isInitialRender) {
                                    let paramsLambda = () => {
                                        return {
                                            url: item,
                                            index: index,
                                            mListener: this.mUrlSelectedListener
                                        };
                                    };
                                    ViewPU.create(new UrlSelectItem(this, { url: item, index: index, mListener: this.mUrlSelectedListener }, undefined, elmtId, paramsLambda, { page: "amdemos-player-ohos-listapp/src/main/ets/pages/UrlSelectPage.ets", line: 75 }));
                                }
                                else {
                                    this.updateStateVarsOfChildByElmtId(elmtId, {
                                        url: item, index: index
                                    });
                                }
                            }, { name: "UrlSelectItem" });
                        }
                        ListItem.pop();
                    };
                    this.observeComponentCreation2(itemCreation2, ListItem);
                    ListItem.pop();
                }
            };
            this.forEachUpdateFunction(elmtId, this.allVideoList, forEachItemGenFunction, undefined, true, false);
        }, ForEach);
        ForEach.pop();
        List.pop();
        Column.pop();
        Row.pop();
    }
    rerender() {
        this.updateDirtyElements();
    }
    static getEntryName(): string {
        return "UrlSelectPage";
    }
}
class UrlSelectItem extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1, paramsLambda = undefined, extraInfo) {
        super(parent, __localStorage, elmtId, extraInfo);
        if (typeof paramsLambda === "function") {
            this.paramsGenerator_ = paramsLambda;
        }
        this.__url = new SynchedPropertySimpleOneWayPU(params.url, this, "url");
        this.__index = new SynchedPropertySimpleOneWayPU(params.index, this, "index");
        this.mListener = undefined;
        this.setInitiallyProvidedValue(params);
    }
    setInitiallyProvidedValue(params: UrlSelectItem_Params) {
        if (params.url === undefined) {
            this.__url.set('');
        }
        if (params.index === undefined) {
            this.__index.set(0);
        }
        if (params.mListener !== undefined) {
            this.mListener = params.mListener;
        }
    }
    updateStateVars(params: UrlSelectItem_Params) {
        this.__url.reset(params.url);
        this.__index.reset(params.index);
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
        this.__url.purgeDependencyOnElmtId(rmElmtId);
        this.__index.purgeDependencyOnElmtId(rmElmtId);
    }
    aboutToBeDeleted() {
        this.__url.aboutToBeDeleted();
        this.__index.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    private __url: SynchedPropertySimpleOneWayPU<string>;
    get url() {
        return this.__url.get();
    }
    set url(newValue: string) {
        this.__url.set(newValue);
    }
    private __index: SynchedPropertySimpleOneWayPU<number>;
    get index() {
        return this.__index.get();
    }
    set index(newValue: number) {
        this.__index.set(newValue);
    }
    private mListener?: OnCheckboxSelected;
    initialRender() {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Row.create();
            Row.width('100%');
            Row.height(100);
            Row.backgroundColor('#dddddd');
            Row.alignItems(VerticalAlign.Center);
            Row.margin({ bottom: 10 });
        }, Row);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Text.create(this.url);
            Text.width('88%');
            Text.margin({ left: '3%' });
            Text.onClick(() => {
                router.pushUrl({ url: 'pages/PlayerPage', params: { videoUrl: this.url } });
            });
        }, Text);
        Text.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Checkbox.create();
            Checkbox.width('5%');
            Checkbox.onChange((selected: boolean) => {
                showToast("selected: " + selected + " " + this.index);
                this.mListener?.onCheckboxChange(selected, this.index);
            });
        }, Checkbox);
        Checkbox.pop();
        Row.pop();
    }
    rerender() {
        this.updateDirtyElements();
    }
}
interface OnCheckboxSelected {
    onCheckboxChange: (selected: boolean, index: number) => void;
}
registerNamedRoute(() => new UrlSelectPage(undefined, {}), "", { bundleName: "com.aliyun.player.ohos_demo", moduleName: "listapp", pagePath: "pages/UrlSelectPage" });
