interface HeaderComponent_Params {
    isSupportBackClick?: boolean;
    title?: string;
    rightTitle?: string;
    settingsClickUrl?: string;
    rightListener?: onRightClickListener | undefined;
}
import router from "@ohos:router";
export class HeaderComponent extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1, paramsLambda = undefined, extraInfo) {
        super(parent, __localStorage, elmtId, extraInfo);
        if (typeof paramsLambda === "function") {
            this.paramsGenerator_ = paramsLambda;
        }
        this.__isSupportBackClick = new ObservedPropertySimplePU(true, this, "isSupportBackClick");
        this.__title = new ObservedPropertySimplePU('标题', this, "title");
        this.__rightTitle = new ObservedPropertySimplePU('设置', this, "rightTitle");
        this.__settingsClickUrl = new ObservedPropertySimplePU('', this, "settingsClickUrl");
        this.rightListener = undefined;
        this.setInitiallyProvidedValue(params);
    }
    setInitiallyProvidedValue(params: HeaderComponent_Params) {
        if (params.isSupportBackClick !== undefined) {
            this.isSupportBackClick = params.isSupportBackClick;
        }
        if (params.title !== undefined) {
            this.title = params.title;
        }
        if (params.rightTitle !== undefined) {
            this.rightTitle = params.rightTitle;
        }
        if (params.settingsClickUrl !== undefined) {
            this.settingsClickUrl = params.settingsClickUrl;
        }
        if (params.rightListener !== undefined) {
            this.rightListener = params.rightListener;
        }
    }
    updateStateVars(params: HeaderComponent_Params) {
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
        this.__isSupportBackClick.purgeDependencyOnElmtId(rmElmtId);
        this.__title.purgeDependencyOnElmtId(rmElmtId);
        this.__rightTitle.purgeDependencyOnElmtId(rmElmtId);
        this.__settingsClickUrl.purgeDependencyOnElmtId(rmElmtId);
    }
    aboutToBeDeleted() {
        this.__isSupportBackClick.aboutToBeDeleted();
        this.__title.aboutToBeDeleted();
        this.__rightTitle.aboutToBeDeleted();
        this.__settingsClickUrl.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    private __isSupportBackClick: ObservedPropertySimplePU<boolean>;
    get isSupportBackClick() {
        return this.__isSupportBackClick.get();
    }
    set isSupportBackClick(newValue: boolean) {
        this.__isSupportBackClick.set(newValue);
    }
    private __title: ObservedPropertySimplePU<string>;
    get title() {
        return this.__title.get();
    }
    set title(newValue: string) {
        this.__title.set(newValue);
    }
    private __rightTitle: ObservedPropertySimplePU<string>;
    get rightTitle() {
        return this.__rightTitle.get();
    }
    set rightTitle(newValue: string) {
        this.__rightTitle.set(newValue);
    }
    private __settingsClickUrl: ObservedPropertySimplePU<string>;
    get settingsClickUrl() {
        return this.__settingsClickUrl.get();
    }
    set settingsClickUrl(newValue: string) {
        this.__settingsClickUrl.set(newValue);
    }
    private rightListener: onRightClickListener | undefined;
    initialRender() {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Column.create();
        }, Column);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Row.create();
            Row.width('100%');
            Row.height(50);
            Row.padding({ left: 8, right: 8 });
        }, Row);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Text.create('返回');
            Text.height('100%');
            Text.width(80);
            Text.textAlign(TextAlign.Start);
            Text.visibility(this.isSupportBackClick ? Visibility.Visible : Visibility.Hidden);
            Text.onClick(() => {
                if (this.isSupportBackClick) {
                    router.back();
                }
            });
        }, Text);
        Text.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Blank.create();
        }, Blank);
        Blank.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Text.create(this.title);
            Text.height('100%');
            Text.textAlign(TextAlign.Center);
        }, Text);
        Text.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Blank.create();
        }, Blank);
        Blank.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Text.create(this.rightTitle);
            Text.height('100%');
            Text.width(80);
            Text.textAlign(TextAlign.Center);
            Text.visibility(this.settingsClickUrl || this.rightListener ? Visibility.Visible : Visibility.Hidden);
            Text.onClick(() => {
                if (this.rightListener) {
                    this.rightListener.onRightItemClick();
                    return;
                }
                if (this.settingsClickUrl) {
                    router.pushUrl({ url: this.settingsClickUrl });
                }
            });
        }, Text);
        Text.pop();
        Row.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Divider.create();
            Divider.strokeWidth(1);
            Divider.color('#000000');
        }, Divider);
        Column.pop();
    }
    rerender() {
        this.updateDirtyElements();
    }
}
export interface onRightClickListener {
    onRightItemClick: () => void;
}
