interface ToggleComponent_Params {
    mTitle?: string;
    textSize?: number;
    status?: boolean;
    mOnToggleChangeHandler?: onToggleChangeEventListener;
}
export class ToggleComponent extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1, paramsLambda = undefined, extraInfo) {
        super(parent, __localStorage, elmtId, extraInfo);
        if (typeof paramsLambda === "function") {
            this.paramsGenerator_ = paramsLambda;
        }
        this.__mTitle = new ObservedPropertySimplePU('', this, "mTitle");
        this.__textSize = new ObservedPropertySimplePU(12, this, "textSize");
        this.__status = new ObservedPropertySimplePU(false, this, "status");
        this.__mOnToggleChangeHandler = new SynchedPropertyObjectOneWayPU(params.mOnToggleChangeHandler, this, "mOnToggleChangeHandler");
        this.setInitiallyProvidedValue(params);
    }
    setInitiallyProvidedValue(params: ToggleComponent_Params) {
        if (params.mTitle !== undefined) {
            this.mTitle = params.mTitle;
        }
        if (params.textSize !== undefined) {
            this.textSize = params.textSize;
        }
        if (params.status !== undefined) {
            this.status = params.status;
        }
    }
    updateStateVars(params: ToggleComponent_Params) {
        this.__mOnToggleChangeHandler.reset(params.mOnToggleChangeHandler);
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
        this.__mTitle.purgeDependencyOnElmtId(rmElmtId);
        this.__textSize.purgeDependencyOnElmtId(rmElmtId);
        this.__status.purgeDependencyOnElmtId(rmElmtId);
        this.__mOnToggleChangeHandler.purgeDependencyOnElmtId(rmElmtId);
    }
    aboutToBeDeleted() {
        this.__mTitle.aboutToBeDeleted();
        this.__textSize.aboutToBeDeleted();
        this.__status.aboutToBeDeleted();
        this.__mOnToggleChangeHandler.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    private __mTitle: ObservedPropertySimplePU<string>;
    get mTitle() {
        return this.__mTitle.get();
    }
    set mTitle(newValue: string) {
        this.__mTitle.set(newValue);
    }
    private __textSize: ObservedPropertySimplePU<number>;
    get textSize() {
        return this.__textSize.get();
    }
    set textSize(newValue: number) {
        this.__textSize.set(newValue);
    }
    private __status: ObservedPropertySimplePU<boolean>;
    get status() {
        return this.__status.get();
    }
    set status(newValue: boolean) {
        this.__status.set(newValue);
    }
    private __mOnToggleChangeHandler: SynchedPropertySimpleOneWayPU<onToggleChangeEventListener>;
    get mOnToggleChangeHandler() {
        return this.__mOnToggleChangeHandler.get();
    }
    set mOnToggleChangeHandler(newValue: onToggleChangeEventListener) {
        this.__mOnToggleChangeHandler.set(newValue);
    }
    initialRender() {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Row.create({ space: 10 });
        }, Row);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Text.create(this.mTitle);
            Text.fontSize(this.textSize);
            Text.fontColor(0x111111);
        }, Text);
        Text.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Toggle.create({ type: ToggleType.Switch, isOn: this.status });
            Toggle.selectedColor('#007DFF');
            Toggle.switchPointColor('#FFFFFF');
            Toggle.onChange((isOn: boolean) => {
                this.status = isOn;
                this.mOnToggleChangeHandler.onChange(isOn);
            });
        }, Toggle);
        Toggle.pop();
        Row.pop();
    }
    rerender() {
        this.updateDirtyElements();
    }
}
interface onToggleChangeEventListener {
    onChange: (isOn: boolean) => void;
}
