interface SelectComponent_Params {
    mListener?: OnSelectListener;
    mSelectIndex?: number;
    mTitle?: string;
    mSelectTextArray?: Array<string>;
}
import { Hlog } from "@bundle:com.aliyun.player.ohos_demo/listapp/ets/common/util/Hlog";
const log: Hlog = new Hlog('SelectComponent');
export class SelectComponent extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1, paramsLambda = undefined, extraInfo) {
        super(parent, __localStorage, elmtId, extraInfo);
        if (typeof paramsLambda === "function") {
            this.paramsGenerator_ = paramsLambda;
        }
        this.mListener = undefined;
        this.__mSelectIndex = new ObservedPropertySimplePU(0, this, "mSelectIndex");
        this.__mTitle = new ObservedPropertySimplePU('', this, "mTitle");
        this.__mSelectTextArray = new ObservedPropertyObjectPU([], this, "mSelectTextArray");
        this.setInitiallyProvidedValue(params);
        this.declareWatch("mSelectIndex", this.onSelectChanged);
    }
    setInitiallyProvidedValue(params: SelectComponent_Params) {
        if (params.mListener !== undefined) {
            this.mListener = params.mListener;
        }
        if (params.mSelectIndex !== undefined) {
            this.mSelectIndex = params.mSelectIndex;
        }
        if (params.mTitle !== undefined) {
            this.mTitle = params.mTitle;
        }
        if (params.mSelectTextArray !== undefined) {
            this.mSelectTextArray = params.mSelectTextArray;
        }
    }
    updateStateVars(params: SelectComponent_Params) {
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
        this.__mSelectIndex.purgeDependencyOnElmtId(rmElmtId);
        this.__mTitle.purgeDependencyOnElmtId(rmElmtId);
        this.__mSelectTextArray.purgeDependencyOnElmtId(rmElmtId);
    }
    aboutToBeDeleted() {
        this.__mSelectIndex.aboutToBeDeleted();
        this.__mTitle.aboutToBeDeleted();
        this.__mSelectTextArray.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    private mListener?: OnSelectListener;
    private __mSelectIndex: ObservedPropertySimplePU<number>;
    get mSelectIndex() {
        return this.__mSelectIndex.get();
    }
    set mSelectIndex(newValue: number) {
        this.__mSelectIndex.set(newValue);
    }
    private __mTitle: ObservedPropertySimplePU<string>;
    get mTitle() {
        return this.__mTitle.get();
    }
    set mTitle(newValue: string) {
        this.__mTitle.set(newValue);
    }
    private __mSelectTextArray: ObservedPropertyObjectPU<Array<string>>;
    get mSelectTextArray() {
        return this.__mSelectTextArray.get();
    }
    set mSelectTextArray(newValue: Array<string>) {
        this.__mSelectTextArray.set(newValue);
    }
    private onSelectChanged() {
        log.i(`onSelectChanged: ${this.mSelectIndex}`);
        this.mListener?.onSelectChanged(this.mSelectIndex);
    }
    initialRender() {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Row.create();
            Row.height(34);
            Row.width('100%');
        }, Row);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Text.create(this.mTitle);
            Text.width('20%');
            Text.height('100%');
            Text.textAlign(TextAlign.Center);
        }, Text);
        Text.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            ForEach.create();
            const forEachItemGenFunction = (_item, index) => {
                const item = _item;
                this.SelectText.bind(this)(item, index);
            };
            this.forEachUpdateFunction(elmtId, this.mSelectTextArray, forEachItemGenFunction, undefined, true, false);
        }, ForEach);
        ForEach.pop();
        Row.pop();
    }
    SelectText(title: string, index: number, parent = null) {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Text.create(title);
            Text.width(this.getItemWidth(this.mSelectTextArray.length));
            Text.height('100%');
            Text.textAlign(TextAlign.Center);
            Text.border({ width: 0.5, color: { "id": 16777223, "type": 10001, params: [], "bundleName": "com.aliyun.player.ohos_demo", "moduleName": "listapp" } });
            Text.backgroundColor(this.mSelectIndex == index ? { "id": 16777223, "type": 10001, params: [], "bundleName": "com.aliyun.player.ohos_demo", "moduleName": "listapp" } : { "id": 16777221, "type": 10001, params: [], "bundleName": "com.aliyun.player.ohos_demo", "moduleName": "listapp" });
            Text.fontColor(this.mSelectIndex == index ? { "id": 16777224, "type": 10001, params: [], "bundleName": "com.aliyun.player.ohos_demo", "moduleName": "listapp" } : { "id": 16777222, "type": 10001, params: [], "bundleName": "com.aliyun.player.ohos_demo", "moduleName": "listapp" });
            Text.onClick(() => {
                this.mSelectIndex = index;
            });
        }, Text);
        Text.pop();
    }
    private getItemWidth(itemSize?: number) {
        if (!itemSize) {
            return '0%';
        }
        switch (itemSize) {
            case 1:
                return '80%';
            case 2:
                return '40%';
            case 3:
                return '26.66%';
            case 4:
                return '20%';
            case 5:
                return '16%';
        }
        return '0%';
    }
    rerender() {
        this.updateDirtyElements();
    }
}
export interface OnSelectListener {
    onSelectChanged: (selectIndex: number) => void;
}
