import premierlibrary from '@app:com.aliyun.player.ohos_demo/listapp/premierlibrary';
import { Log } from '@package:pkg_modules/.ohpm/premierlibrary@donfdoen1mcr6ssy+rjg6ltkuce=/pkg_modules/premierlibrary/src/main/ets/com/aliyun/utils/Log';
import { InfoBean } from '@package:pkg_modules/.ohpm/premierlibrary@donfdoen1mcr6ssy+rjg6ltkuce=/pkg_modules/premierlibrary/src/main/ets/com/aliyun/player/bean/InfoBean';
import { findInfoCodeByValue, InfoCode } from '@package:pkg_modules/.ohpm/premierlibrary@donfdoen1mcr6ssy+rjg6ltkuce=/pkg_modules/premierlibrary/src/main/ets/com/aliyun/player/bean/InfoCode';
import { findErrorCodeByValue } from '@package:pkg_modules/.ohpm/premierlibrary@donfdoen1mcr6ssy+rjg6ltkuce=/pkg_modules/premierlibrary/src/main/ets/com/aliyun/player/bean/PlayerErrorCode';
import { ErrorInfo } from '@package:pkg_modules/.ohpm/premierlibrary@donfdoen1mcr6ssy+rjg6ltkuce=/pkg_modules/premierlibrary/src/main/ets/com/aliyun/player/bean/ErrorInfo';
const log = new Log('NativePlayerBase');
export class NativePlayerBase {
    constructor(t11) {
        this.mNativeContext = 0;
        this.getNativeContext = () => {
            log.info(`getNativeContext, address: ${this.mNativeContext}`);
            return this.mNativeContext;
        };
        this.setNativeContext = (f14) => {
            log.info(`setNativeContext, address: ${f14}`);
            this.mNativeContext = f14;
        };
        this.getContext = () => {
            log.info(`getNativeContext, address: ${this.mNativeContext}`);
            return this.mContext;
        };
        this.onPrepared = () => {
            console.log('onPrepared called at nativePlayerBase.');
            if (this.mOnPreparedListener != null) {
                this.mOnPreparedListener.onPrepared();
            }
        };
        this.onCircleStart = () => {
            if (this.mOnInfoListener != null) {
                let e14 = new InfoBean();
                e14.setCode(InfoCode.LoopingStart);
                this.mOnInfoListener.onInfo(e14);
            }
        };
        this.onAutoPlayStart = () => {
            if (this.mOnInfoListener != null) {
                let d14 = new InfoBean();
                d14.setCode(InfoCode.AutoPlayStart);
                this.mOnInfoListener.onInfo(d14);
            }
        };
        this.onEvent = (z13, a14) => {
            if (this.mOnInfoListener != null) {
                let b14 = findInfoCodeByValue(z13);
                let c14 = new InfoBean();
                c14.setCode(b14);
                c14.setExtraMsg(a14);
                this.mOnInfoListener.onInfo(c14);
            }
        };
        this.onCurrentDownloadSpeed = (x13) => {
            if (this.mOnInfoListener != null) {
                let y13 = new InfoBean();
                y13.setCode(InfoCode.CurrentDownloadSpeed);
                y13.setExtraValue(x13);
                this.mOnInfoListener.onInfo(y13);
            }
        };
        this.onUtcTimeUpdate = (v13) => {
            if (this.mOnInfoListener != null) {
                let w13 = new InfoBean();
                w13.setCode(InfoCode.UtcTime);
                w13.setExtraValue(v13);
                this.mOnInfoListener.onInfo(w13);
            }
        };
        this.onLocalCacheLoad = (t13) => {
            if (this.mOnInfoListener != null) {
                let u13 = new InfoBean();
                u13.setCode(InfoCode.LocalCacheLoaded);
                u13.setExtraValue(t13);
                this.mOnInfoListener.onInfo(u13);
            }
        };
        this.onBufferedPositionUpdate = (r13) => {
            if (this.mOnInfoListener != null) {
                let s13 = new InfoBean();
                s13.setCode(InfoCode.BufferedPosition);
                s13.setExtraValue(r13);
                this.mOnInfoListener.onInfo(s13);
            }
        };
        this.onCurrentPositionUpdate = (p13) => {
            if (this.mOnInfoListener != null) {
                let q13 = new InfoBean();
                q13.setCode(InfoCode.CurrentPosition);
                q13.setExtraValue(p13);
                this.mOnInfoListener.onInfo(q13);
            }
        };
        this.onFirstFrameShow = () => {
            if (this.mOnRenderingStartListener != null) {
                this.mOnRenderingStartListener.onRenderingStart();
            }
        };
        this.onVideoSizeChanged = (n13, o13) => {
            if (this.mOnVideoSizeChangedListener != null) {
                this.mOnVideoSizeChangedListener.onVideoSizeChanged(n13, o13);
            }
        };
        this.onLoadingStart = () => {
            if (this.mOnLoadingStatusListener != null) {
                this.mOnLoadingStatusListener.onLoadingBegin();
            }
        };
        this.onLoadingProgress = (m13) => {
            if (this.mOnLoadingStatusListener != null) {
                this.mOnLoadingStatusListener.onLoadingProgress(m13, 0);
            }
        };
        this.onLoadingEnd = () => {
            if (this.mOnLoadingStatusListener != null) {
                this.mOnLoadingStatusListener.onLoadingEnd();
            }
        };
        this.onSeekEnd = () => {
            if (this.mOnSeekCompleteListener != null) {
                this.mOnSeekCompleteListener.onSeekComplete();
            }
        };
        this.onStatusChanged = (k13, l13) => {
            log.info('onStatusChanged, newState: ' + k13 + ' oldState: ' + l13);
            if (this.mOnStateChangedListener != null) {
                this.mOnStateChangedListener.onStateChanged(k13);
            }
        };
        this.onCompletion = () => {
            if (this.mOnCompletionListener != null) {
                this.mOnCompletionListener.onCompletion();
            }
        };
        this.onVideoRendered = (i13, j13) => {
            if (this.mOnVideoRenderedListener != null) {
                this.mOnVideoRenderedListener.onVideoRendered(i13, j13);
            }
        };
        this.onShowSubtitle = (f13, g13, h13) => {
            if (this.mOnSubtitleDisplayListener != null) {
                this.mOnSubtitleDisplayListener.onSubtitleShow(f13, g13, h13);
            }
        };
        this.onSubtitleExtAdded = (d13, e13) => {
            if (this.mOnSubtitleDisplayListener != null) {
                this.mOnSubtitleDisplayListener.onSubtitleExtAdded(d13, e13);
            }
        };
        this.onHideSubtitle = (b13, c13) => {
            if (this.mOnSubtitleDisplayListener != null) {
                this.mOnSubtitleDisplayListener.onSubtitleHide(b13, c13);
            }
        };
        this.onSubtitleHeader = (z12, a13) => {
            if (this.mOnSubtitleDisplayListener != null) {
                this.mOnSubtitleDisplayListener.onSubtitleHeader(z12, a13);
            }
        };
        this.onError = (u12, v12, w12) => {
            let x12 = findErrorCodeByValue(u12);
            if (this.mOnErrorListener != null) {
                let y12 = new ErrorInfo();
                y12.setCode(x12);
                y12.setMsg(v12);
                y12.setExtra(w12);
                this.mOnErrorListener.onError(y12);
            }
        };
        log.info('constructor_');
        this.mContext = t11;
        premierlibrary.nConstruct(this);
    }
    setOnPreparedListener(s11) {
        this.mOnPreparedListener = s11;
    }
    setOnInfoListener(r11) {
        this.mOnInfoListener = r11;
    }
    setOnRenderingStartListener(q11) {
        this.mOnRenderingStartListener = q11;
    }
    setOnStateChangedListener(p11) {
        this.mOnStateChangedListener = p11;
    }
    setOnCompletionListener(o11) {
        this.mOnCompletionListener = o11;
    }
    setOnLoadingStatusListener(n11) {
        this.mOnLoadingStatusListener = n11;
    }
    setOnErrorListener(m11) {
        this.mOnErrorListener = m11;
    }
    setOnVideoSizeChangedListener(l11) {
        this.mOnVideoSizeChangedListener = l11;
    }
    setOnSeekCompleteListener(k11) {
        this.mOnSeekCompleteListener = k11;
    }
    setOnSubtitleDisplayListener(j11) {
        this.mOnSubtitleDisplayListener = j11;
    }
    setOnVideoRenderedListener(i11) {
        this.mOnVideoRenderedListener = i11;
    }
    start() {
        log.info('nStart');
        premierlibrary.nStart(this);
    }
    pause() {
        log.info('nPause');
        premierlibrary.nPause(this);
    }
    stop() {
        log.info('nStop');
        premierlibrary.nStop(this);
    }
    prepare() {
        log.info('nPrepare');
        premierlibrary.nPrepare(this);
    }
    setAutoPlay(h11) {
        log.info('nPrepare');
        premierlibrary.nSetAutoPlay(this, h11);
    }
    setSurfaceId(g11) {
        log.info('nSetSurfaceId');
        premierlibrary.nSetSurfaceId(this, g11);
    }
    setSpeed(f11) {
        log.info('setSpeed');
        premierlibrary.nSetSpeed(this, f11);
    }
    setVolume(e11) {
        log.info('setVolume');
        premierlibrary.nSetVolume(this, e11);
    }
    getVolume() {
        log.info('getVolume');
        return premierlibrary.nGetVolume(this);
    }
    seekTo(c11, d11) {
        log.info('seekTo');
        premierlibrary.nSeekTo(this, c11, d11);
    }
    getDuration() {
        log.info('getDuration');
        return premierlibrary.nGetDuration(this);
    }
    getCurrentPosition() {
        log.info('getCurrentPosition');
        return premierlibrary.nGetCurrentPosition(this);
    }
    getBufferedPosition() {
        log.info('getBufferedPosition');
        return premierlibrary.nGetBufferedPosition(this);
    }
    setTraceId(b11) {
        log.info('setTraceId');
        premierlibrary.nSetTraceId(this, b11);
    }
    enableHardwareDecoder(a11) {
        log.info('enableHardwareDecoder');
        premierlibrary.nEnableHardwareDecoder(this, a11);
    }
    release() {
        log.info('release');
        premierlibrary.nRelease(this);
    }
    setMute(z10) {
        log.info('setMute');
        premierlibrary.nSetMute(this, z10);
    }
    isMuted() {
        log.info('isMuted');
        return premierlibrary.nIsMuted(this) === 1;
    }
    setScaleMode(y10) {
        log.info('setScaleMode');
        premierlibrary.nSetScaleMode(this, y10);
    }
    getScaleMode() {
        log.info('getScaleMode');
        return premierlibrary.nGetScaleMode(this);
    }
    setLoop(x10) {
        log.info('setLoop');
        premierlibrary.nSetLoop(this, x10);
    }
    isLoop() {
        log.info('isLoop');
        return premierlibrary.nIsLoop(this) === 1;
    }
    getVideoWidth() {
        log.info('getVideoWidth');
        return premierlibrary.nGetVideoWidth(this);
    }
    getVideoHeight() {
        log.info('getVideoHeight');
        return premierlibrary.nGetVideoHeight(this);
    }
    getVideoRotation() {
        log.info('getVideoRotation');
        return premierlibrary.nGetVideoRotation(this);
    }
    reload() {
        log.info('reload');
        premierlibrary.nReload(this);
    }
    setRotateMode(w10) {
        log.info('setRotateMode');
        premierlibrary.nSetRotateMode(this, w10);
    }
    getRotateMode() {
        log.info('getRotateMode');
        return premierlibrary.nGetRotateMode(this);
    }
    setMirrorMode(v10) {
        log.info('setMirrorMode');
        premierlibrary.nSetMirrorMode(this, v10);
    }
    getMirrorMode() {
        log.info('getMirrorMode');
        return premierlibrary.nGetMirrorMode(this);
    }
    setVideoBackgroundColor(u10) {
        log.info('setVideoBackgroundColor');
        premierlibrary.nSetVideoBackgroundColor(this, u10);
    }
    getSpeed() {
        log.info('getSpeed');
        return premierlibrary.nGetSpeed(this);
    }
    isAutoPlay() {
        log.info('isAutoPlay');
        return premierlibrary.nIsAutoPlay(this) === 1;
    }
    setConfig(t10) {
        log.info('setConfig');
        premierlibrary.nSetConfig(this, t10);
        this.mPlayerConfig = t10;
    }
    getConfig() {
        return this.mPlayerConfig;
    }
    getNativeContextAddr() {
        return this.mNativeContext;
    }
}
