export class PlayerConfig {
    constructor() {
        this.mHttpProxy = "";
        this.mReferrer = "";
        this.mNetworkTimeout = 15000;
        this.mMaxDelayTime = 5000;
        this.mMaxBufferDuration = 50000;
        this.mHighBufferDuration = 3000;
        this.mStartBufferDuration = 500;
        this.mMaxProbeSize = -1;
        this.mClearFrameWhenStop = false;
        this.mEnableVideoTunnelRender = false;
        this.mEnableVideoBufferRender = false;
        this.mEnableSEI = false;
        this.mUserAgent = "";
        this.mNetworkRetryCount = 2;
        this.mLiveStartIndex = -3;
        this.mDisableAudio = false;
        this.mDisableVideo = false;
        this.mPositionTimerIntervalMs = 500;
        this.mMaxBackwardBufferDurationMs = 0;
        this.mPreferAudio = false;
        this.mEnableLocalCache = true;
        this.mEnableHttpDns = -1;
        this.mEnableHttp3 = false;
        this.mEnableStrictFlvHeader = false;
        this.mEnableLowLatencyMode = false;
        this.mEnableProjection = false;
        this.mEnableStrictAuthMode = false;
        this.mStartBufferLimit = 15000;
        this.mStopBufferLimit = 3000;
        this.nativeGetHttpProxy = () => {
            return this.mHttpProxy;
        };
        this.nativeGetReferrer = () => {
            return this.mReferrer;
        };
        this.nativeGetNetworkTimeout = () => {
            return this.mNetworkTimeout;
        };
        this.nativeGetMaxDelayTime = () => {
            return this.mMaxDelayTime;
        };
        this.nativeGetMaxBufferDuration = () => {
            return this.mMaxBufferDuration;
        };
        this.nativeGetHighBufferDuration = () => {
            return this.mHighBufferDuration;
        };
        this.nativeGetStartBufferDuration = () => {
            return this.mStartBufferDuration;
        };
        this.nativeGetMaxProbeSize = () => {
            return this.mMaxProbeSize;
        };
        this.nativeGetClearFrameWhenStop = () => {
            return this.mClearFrameWhenStop;
        };
        this.nativeGetEnableVideoTunnelRender = () => {
            return this.mEnableVideoTunnelRender;
        };
        this.nativeGetEnableVideoBufferRender = () => {
            return this.mEnableVideoBufferRender;
        };
        this.nativeGetEnableSEI = () => {
            return this.mEnableSEI;
        };
        this.nativeGetUserAgent = () => {
            return this.mUserAgent;
        };
        this.nativeGetNetworkRetryCount = () => {
            return this.mNetworkRetryCount;
        };
        this.nativeGetLiveStartIndex = () => {
            return this.mLiveStartIndex;
        };
        this.nativeGetDisableAudio = () => {
            return this.mDisableAudio;
        };
        this.nativeGetDisableVideo = () => {
            return this.mDisableVideo;
        };
        this.nativeGetPositionTimerIntervalMs = () => {
            return this.mPositionTimerIntervalMs;
        };
        this.nativeGetMaxBackwardBufferDurationMs = () => {
            return this.mMaxBackwardBufferDurationMs;
        };
        this.nativeGetPreferAudio = () => {
            return this.mPreferAudio;
        };
        this.nativeGetEnableLocalCache = () => {
            return this.mEnableLocalCache;
        };
        this.nativeGetEnableHttpDns = () => {
            return this.mEnableHttpDns;
        };
        this.nativeGetEnableHttp3 = () => {
            return this.mEnableHttp3;
        };
        this.nativeGetEnableStrictFlvHeader = () => {
            return this.mEnableStrictFlvHeader;
        };
        this.nativeGetEnableLowLatencyMode = () => {
            return this.mEnableLowLatencyMode;
        };
        this.nativeGetEnableProjection = () => {
            return this.mEnableProjection;
        };
        this.nativeGetEnableStrictAuthMode = () => {
            return this.mEnableStrictAuthMode;
        };
        this.nativeGetStartBufferLimit = () => {
            return this.mStartBufferLimit;
        };
        this.nativeGetStopBufferLimit = () => {
            return this.mStopBufferLimit;
        };
        this.nativeGetCustomHeaders = () => {
            return this.mCustomHeaders;
        };
        this.nativeGetCustomHeadersNumber = () => {
            var a16;
            return (a16 = this.mCustomHeaders) === null || a16 === void 0 ? void 0 : a16.length;
        };
        this.nativeGetCustomHeader = (z15) => {
            if (this.mCustomHeaders && z15 < this.mCustomHeaders.length) {
                return this.mCustomHeaders[z15];
            }
            return undefined;
        };
    }
    getCustomHeaders() {
        return this.mCustomHeaders;
    }
    setCustomHeaders(s14) {
        this.mCustomHeaders = s14;
    }
}
