export class AVPLBase {
    constructor(e9, f9) {
        this.mNativePlayer = this.getNativePlayerWithContext(e9, f9);
        this.mPreRenderPlayer = this.getPrerenderPlayerWithContext(e9, f9);
        this.mListPlayer = this.createListPlayer(e9, f9, this.mNativePlayer.getNativeContextAddr(), this.mPreRenderPlayer.getNativeContextAddr());
    }
    getCurrentPlayer() {
        let d9 = this.getCurrentPlayerIndex();
        if (d9 == 1) {
            return this.mPreRenderPlayer;
        }
        else {
            return this.mNativePlayer;
        }
    }
    getCurrentPrerenderPlayer(c9) {
        if (c9 == 0) {
            return this.mNativePlayer;
        }
        else if (c9 == 1) {
            return this.mPreRenderPlayer;
        }
        return undefined;
    }
    getCorePlayer() {
        return this.mListPlayer;
    }
    getNativePlayer() {
        return this.mNativePlayer;
    }
    getPrerenderPlayer() {
        return this.mPreRenderPlayer;
    }
    removeSource(a9) {
        var b9;
        (b9 = this.mListPlayer) === null || b9 === void 0 ? void 0 : b9.removeSource(a9);
    }
    clear() {
        var z8;
        (z8 = this.mListPlayer) === null || z8 === void 0 ? void 0 : z8.clear();
    }
    getCurrentUid() {
        var y8;
        return (y8 = this.mListPlayer) === null || y8 === void 0 ? void 0 : y8.getCurrentUid();
    }
    setMaxPreloadMemorySizeMB(w8) {
        var x8;
        (x8 = this.mListPlayer) === null || x8 === void 0 ? void 0 : x8.setMaxPreloadMemorySizeMB(w8);
    }
    getMaxPreloadMemorySizeMB() {
        var v8;
        return (v8 = this.mListPlayer) === null || v8 === void 0 ? void 0 : v8.getMaxPreloadMemorySizeMB();
    }
    setPreloadCount(t8) {
        var u8;
        (u8 = this.mListPlayer) === null || u8 === void 0 ? void 0 : u8.setPreloadCount(t8);
    }
    setPreloadScene(r8) {
        var s8;
        (s8 = this.mListPlayer) === null || s8 === void 0 ? void 0 : s8.setPreloadScene(r8);
    }
    enablePreloadStrategy(o8, p8) {
        var q8;
        (q8 = this.mListPlayer) === null || q8 === void 0 ? void 0 : q8.enablePreloadStrategy(o8, p8);
    }
    setPreloadStrategy(l8, m8) {
        var n8;
        (n8 = this.mListPlayer) === null || n8 === void 0 ? void 0 : n8.setPreloadStrategyParam(l8, m8);
    }
    setPreloadCountWithPrevAndNext(i8, j8) {
        var k8;
        (k8 = this.mListPlayer) === null || k8 === void 0 ? void 0 : k8.setPreloadCountWithPrevAndNext(i8, j8);
    }
    getNativeContextAddr() {
        var h8;
        return (h8 = this.getCurrentPlayer()) === null || h8 === void 0 ? void 0 : h8.getNativeContextAddr();
    }
    prepare() {
        this.getCurrentPlayer().prepare();
    }
    start() {
        var g8;
        (g8 = this.getCurrentPlayer()) === null || g8 === void 0 ? void 0 : g8.start();
    }
    pause() {
        this.getCurrentPlayer().pause();
    }
    stop() {
        this.getCurrentPlayer().stop();
    }
    setAutoPlay(f8) {
        this.getCurrentPlayer().setAutoPlay(f8);
    }
    setSurfaceId(e8) {
        this.getCurrentPlayer().setSurfaceId(e8);
    }
    setSpeed(d8) {
        this.getCurrentPlayer().setSpeed(d8);
    }
    setVolume(c8) {
        this.getCurrentPlayer().setVolume(c8);
    }
    getVolume() {
        return this.getCurrentPlayer().getVolume();
    }
    seekTo(a8, b8) {
        this.getCurrentPlayer().seekTo(a8, b8);
    }
    getDuration() {
        return this.getCurrentPlayer().getDuration();
    }
    getCurrentPosition() {
        return this.getCurrentPlayer().getCurrentPosition();
    }
    getBufferedPosition() {
        return this.getCurrentPlayer().getBufferedPosition();
    }
    enableHardwareDecoder(z7) {
        this.getCurrentPlayer().enableHardwareDecoder(z7);
    }
    release() {
        this.getCurrentPlayer().release();
    }
    setMute(y7) {
        this.getCurrentPlayer().setMute(y7);
    }
    isMuted() {
        return this.getCurrentPlayer().isMuted();
    }
    setScaleMode(x7) {
        this.getCurrentPlayer().setScaleMode(x7);
    }
    getScaleMode() {
        return this.getCurrentPlayer().getScaleMode();
    }
    setLoop(w7) {
        this.getCurrentPlayer().setLoop(w7);
    }
    isLoop() {
        return this.getCurrentPlayer().isLoop();
    }
    getVideoWidth() {
        return this.getCurrentPlayer().getVideoWidth();
    }
    getVideoHeight() {
        return this.getCurrentPlayer().getVideoHeight();
    }
    getVideoRotation() {
        return this.getCurrentPlayer().getVideoRotation();
    }
    reload() {
        this.getCurrentPlayer().reload();
    }
    setRotateMode(v7) {
        this.getCurrentPlayer().setRotateMode(v7);
    }
    getRotateMode() {
        return this.getCurrentPlayer().getRotateMode();
    }
    setMirrorMode(u7) {
        this.getCurrentPlayer().setMirrorMode(u7);
    }
    getMirrorMode() {
        return this.getCurrentPlayer().getMirrorMode();
    }
    setVideoBackgroundColor(t7) {
        this.getCurrentPlayer().setVideoBackgroundColor(t7);
    }
    getSpeed() {
        return this.getCurrentPlayer().getSpeed();
    }
    isAutoPlay() {
        return this.getCurrentPlayer().isAutoPlay();
    }
    setConfig(s7) {
        if (this.mNativePlayer != null) {
            this.mNativePlayer.setConfig(s7);
        }
        if (this.mPreRenderPlayer != null) {
            this.mPreRenderPlayer.setConfig(s7);
        }
    }
    getConfig() {
        return this.getCurrentPlayer().getConfig();
    }
    setOnPreparedListener(r7) {
        this.getCurrentPlayer().setOnPreparedListener(r7);
    }
    setOnInfoListener(q7) {
        this.getCurrentPlayer().setOnInfoListener(q7);
    }
    setOnRenderingStartListener(p7) {
        this.getCurrentPlayer().setOnRenderingStartListener(p7);
    }
    setOnStateChangedListener(o7) {
        this.getCurrentPlayer().setOnStateChangedListener(o7);
    }
    setOnCompletionListener(n7) {
        this.getCurrentPlayer().setOnCompletionListener(n7);
    }
    setOnLoadingStatusListener(m7) {
        this.getCurrentPlayer().setOnLoadingStatusListener(m7);
    }
    setOnErrorListener(l7) {
        this.getCurrentPlayer().setOnErrorListener(l7);
    }
    setOnVideoSizeChangedListener(k7) {
        this.getCurrentPlayer().setOnVideoSizeChangedListener(k7);
    }
    setOnSeekCompleteListener(j7) {
        this.getCurrentPlayer().setOnSeekCompleteListener(j7);
    }
    setOnSubtitleDisplayListener(i7) {
        this.getCurrentPlayer().setOnSubtitleDisplayListener(i7);
    }
    setOnVideoRenderedListener(h7) {
        this.getCurrentPlayer().setOnVideoRenderedListener(h7);
    }
}
