"use strict";var __importDefault=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(exports,"__esModule",{value:!0}),exports.watch=exports.compileCodeSnippet=exports.loadAceBuildJson=exports.getResolveModules=exports.runArkPack=void 0;const hvigor_arkts_base_1=require("@ohos/hvigor-arkts-base"),plugin_commonjs_1=__importDefault(require("@rollup/plugin-commonjs")),plugin_json_1=__importDefault(require("@rollup/plugin-json")),plugin_node_resolve_1=__importDefault(require("@rollup/plugin-node-resolve")),fs_1=__importDefault(require("fs")),os_1=__importDefault(require("os")),path_1=__importDefault(require("path")),index_js_1=__importDefault(require("../src/plugins/node-resolve/index.js")),compile_event_factory_js_1=require("./analyzer/compile-event-factory.js"),compile_perf_js_1=require("./analyzer/compile-perf.js"),compose_error_js_1=require("./data/compose-error.js"),common_plugin_js_1=require("./plugins/common-plugin.js"),copy_plugin_js_1=__importDefault(require("./plugins/copy-plugin.js")),delete_plugin_js_1=__importDefault(require("./plugins/delete-plugin.js")),ignore_plugin_js_1=require("./plugins/ignore-plugin.js"),invalid_cache_plugin_js_1=require("./plugins/invalid-cache-plugin.js"),module_meta_info_plugin_js_1=require("./plugins/module-meta-info-plugin.js"),preview_resource_watcher_plugin_js_1=require("./plugins/preview-resource-watcher-plugin.js"),wait_async_plugin_js_1=require("./plugins/wait-async-plugin.js"),wrapper_chunk_plugin_js_1=require("./plugins/wrapper-chunk-plugin.js"),constants_js_1=require("./util/constants.js"),copy_resources_js_1=require("./util/copy-resources.js"),load_sdk_functions_js_1=require("./util/load-sdk-functions.js"),compile_code_snippet_js_1=require("./work-scripts/compile-code-snippet.js"),PROCESS_UN_HANDLED_REJECTION="unhandledRejection",PROCESS_UN_CAUGHT_EXCEPTION="uncaughtException",logger=hvigor_arkts_base_1.ArktsBaseLogger.getLogger("arkts-pack"),defaultProjectConfig={watchMode:"false",isPreview:!1,buildMode:constants_js_1.RELEASE,compileMode:constants_js_1.JSBUNDLE},getMergedConfig=e=>{const t={...defaultProjectConfig},r=new Set([...Object.keys(defaultProjectConfig),...Object.keys(e)]);for(const s of r)void 0!==e[s]&&(t[s]=e[s]);return t};function addCompilerLogMsg(e){let t=`${e}${os_1.default.EOL}`,r=1,s=0,o=0,n="",a="",i="";const l="[31m",u="[39m";return hvigor_arkts_base_1.ArktsBaseLogger.getLogEvents().forEach((e=>{"error"===e.level&&(r++,n+=`${l}ERROR: ${e.msg}${u}${os_1.default.EOL}`),"warn"===e.level&&(s++,a+=`[33mWARN: ${e.msg}${u}${os_1.default.EOL}`),"info"===e.level&&(o++,i+=`[34mINFO: ${e.msg}${u}${os_1.default.EOL}`)})),t=`${t}${n}${a}${i}${l}COMPILE RESULT:FAIL {ERROR:${r}`+(0===s?"":` WARN:${s}`)+`${0===o?"":` INFO:${o}`}}${u}`,t}let watcher,isWatchFirst=!0;const setWatcher=e=>{watcher=e};function registerCatchUnhandleError(e,t,r,s){process.on(PROCESS_UN_HANDLED_REJECTION,(e=>{throw e})),process.on(PROCESS_UN_CAUGHT_EXCEPTION,(o=>{if("true"===e.watchMode)return watcher?.resolveDonePromise(),s?.error(o),void r?.postMessage(isWatchFirst?{event:hvigor_arkts_base_1.WatchEvent.WATCH_WORK_ERROR}:{type:hvigor_arkts_base_1.WatchEvent.WATCH_RESULT,content:!1});if(o.name===compose_error_js_1.ARKTS_COMPILER_ERROR_NAME){const e=o,r=new Error(addCompilerLogMsg(o.message));throw e.stack&&r.stack&&(r.stack=r.stack.concat(os_1.default.EOL).concat(e.stack)),t(r),r}throw o}))}function getRollupErrorMessage(e){return e.loc&&e.loc.file?`${e.message+os_1.default.EOL+e.loc.file}:${e.loc.line}`:e.message}async function runArkPack(e,t,r,s,o,n){e.startEvent=e=>compile_event_factory_js_1.CompileEventFactory.createEvent(e,0,0).start().getId(),e.endEvent=e=>compile_event_factory_js_1.CompileEventFactory.getEventById(e)?.stop();const a=new compile_perf_js_1.CompilePerf(e.perf).clear();let i;hvigor_arkts_base_1.ArktsBaseLogger.clearLogEvents(),isWatchFirst=!0,registerCatchUnhandleError(e,t,s,o);try{await collectCompilePerf(e,a,r,s,o,n)}catch(e){if(e instanceof Error){const t="RollupError"===e.name?getRollupErrorMessage(e):e.message;i=new compose_error_js_1.ArkTsCompilerError(t,e.stack)}else i="string"==typeof e?new Error(e):e}if(isWatchFirst=!1,hvigor_arkts_base_1.ArktsBaseLogger.checkLoggerHaveErrorInfo()&&"true"!==e.watchMode&&!i&&(i=new compose_error_js_1.ArkTsCompilerError("ArkTS Compiler Error")),"true"!==e.watchMode&&clearWorkerProcessContext(),i){if(i.name===compose_error_js_1.ARKTS_COMPILER_ERROR_NAME){const e=new Error(addCompilerLogMsg(i.message));i.stack&&e.stack&&(e.stack=e.stack.concat(os_1.default.EOL).concat(i.stack)),i=e}return{compileLogEvents:[],compileEvents:[],isSuccess:!1,error:i}}return{compileLogEvents:hvigor_arkts_base_1.ArktsBaseLogger.getLogEvents(),compileEvents:updateEventNames(Array.from(a.transform())),isSuccess:!0}}async function collectCompilePerf(e,t,r,s,o,n){const a=e.startEvent("generate configuration information"),i=generateConfig(e,o,n);if(e.endEvent(a),i.input&&Object.keys(i.input).length>0){const n=()=>e.isPreview&&s&&(0,compile_code_snippet_js_1.initServer)(e.cachePath,e.aceModuleBuild,e.etsLoaderPath,s),a=e=>o?.error(e);collectTimers(await(0,hvigor_arkts_base_1.runHvigorCompile)(i,r,s,n,setWatcher,a),t)}}function collectTimers(e,t){if(e)for(const[r,[s,o,n,a]]of Object.entries(e))t.collect({name:r,time:s,startTime:o,endTime:n,frequency:a})}function clearProcessListeners(){process.removeAllListeners(PROCESS_UN_CAUGHT_EXCEPTION),process.removeAllListeners(PROCESS_UN_HANDLED_REJECTION)}function clearWorkerProcessContext(){(0,load_sdk_functions_js_1.clearSdkContext)(),clearProcessListeners()}function getResolveModules(e){const t=e.packageManagerType===constants_js_1.OHPM?constants_js_1.OH_NODE_MODULES:constants_js_1.NODE_MODULES,r=path_1.default.resolve(e.aceModuleRoot),s=path_1.default.resolve(e.projectTopDir),o=path_1.default.resolve(e.modulePath),n=e.buildGeneratedProfilePath;return e.resolveModulePaths=[r,o,path_1.default.resolve(o,t),path_1.default.resolve(o,"src/main"),path_1.default.resolve(o,"src/main/ets"),n,path_1.default.resolve(s,t)],e.resolveModulePaths}function loadAceBuildJson(e){if(e&&fs_1.default.existsSync(e))try{return JSON.parse(fs_1.default.readFileSync(e).toString())}catch(e){logger.error(`parse loader.json failed: ${e.message}`)}return{}}function getHarExternal(e){const t=[],r=loadAceBuildJson(e.aceBuildJson);if(e.compileMode===constants_js_1.ESMODULE&&r.harNameOhmMap)for(const e in r.harNameOhmMap)t.push(new RegExp(`^(${e})($|/\\S+)`));return t}function getPlugins(e,t,r){const s=[...getBuiltInPlugins(e,r)];return loadCustomCompilePlugins(e.hvigorPluginFile,t).forEach((r=>{const o=r.order??"last";if("first"===o&&s.unshift(doWrapper(r,e)),"last"===o&&s.push(doWrapper(r,e)),"function"==typeof o){const n={};s.forEach(((e,t)=>{let r=e.name,s=1;for(;n[r];)r=`${r}_${s}`,s++;n[r]=t}));const a=o(n);"number"!=typeof a&&t?._buildError(`'${e.hvigorPluginFile}' exports an invalid plugin '${r.name}' with invalid order return '${a}'. Must return a number value.`)._printErrorAndExit(),s.splice(a<0?0:a,0,doWrapper(r,e))}})),s}function getBuiltInPlugins(e,t){const r=getResolveModules(e),s=constants_js_1.SUPPORT_EXTENSIONS;s.push(...load_sdk_functions_js_1.sdkSupportExtensions);const o=e.globalModulePaths??[];return o.push(path_1.default.resolve(e.etsLoaderPath,"../../api")),[e.isPreview&&e.appResource&&(0,preview_resource_watcher_plugin_js_1.previewResourceWatcherPlugin)(generatePreviewResourceFiles(e)),(0,copy_plugin_js_1.default)({targets:(0,copy_resources_js_1.getCopyPluginConfig)(e,e.appResource)}),(0,common_plugin_js_1.commonPlugin)(e,t),(0,invalid_cache_plugin_js_1.invalidCachePlugin)(),e.packageManagerType===constants_js_1.OHPM?(0,index_js_1.default)({extensions:s,modulePaths:[path_1.default.resolve(constants_js_1.OH_NODE_MODULES),...r,...o],useRealpathCache:!0,preferBuiltins:!1}):(0,plugin_node_resolve_1.default)({extensions:s,modulePaths:[path_1.default.resolve(constants_js_1.NODE_MODULES),path_1.default.resolve(e.etsLoaderPath,constants_js_1.NODE_MODULES),...r,...o],preferBuiltins:!1}),e.compileMode===constants_js_1.ESMODULE&&(0,module_meta_info_plugin_js_1.moduleMetaInfoPlugin)(s),(0,plugin_commonjs_1.default)(),(0,plugin_json_1.default)(),(0,ignore_plugin_js_1.ignorePlugin)(/\.d$|\.d\.e?ts$|^lib\S+\.so/),(0,wrapper_chunk_plugin_js_1.wrapperChunkPlugin)(),(0,wait_async_plugin_js_1.waitAsyncPlugin)(),...load_sdk_functions_js_1.sdkPlugins,!e.isPreview&&(0,delete_plugin_js_1.default)({targets:load_sdk_functions_js_1.cleanConfig,runOnce:!0})].filter((e=>"object"==typeof e))}function generatePreviewResourceFiles(e){return[path_1.default.resolve(__dirname,e.appResource),path_1.default.resolve(e.modulePath,e.packageManagerType===constants_js_1.OHPM?constants_js_1.OH_PACKAGE_JSON5:constants_js_1.PACKAGE_JSON)]}function loadCustomCompilePlugins(e,t){const r=[];if(!e)return r;let s;delete require.cache[require.resolve(e)];try{s=require(e).default}catch(t){throw t.message=`${t.message} ${e}`,t}s||t?._buildError(`'${e}' has no default export.`)._printErrorAndExit();return(Array.isArray(s)?s:[s]).forEach((s=>{validatePlugin(s,e,t),s||t?._buildError(`'${e}' exports an undefined plugin.`)._printErrorAndExit(),r.push(s)})),r}function validatePlugin(e,t,r){"object"!=typeof e&&r?._buildError(`'${t}' exports an invalid plugin with type '${typeof e}'.`)._printErrorAndExit();const s=e.name;s||r?._buildError(`'${t}' exports an invalid plugin without a name.`)._printErrorAndExit(),"string"!=typeof s&&r?._buildError(`'${t}' exports an invalid plugin whose name is not a string.`)._printErrorAndExit(),Object.keys(e).forEach((o=>{const n=e[o];switch(o){case"name":break;case"order":n&&"last"!==n&&"first"!==n&&"function"!=typeof n&&r?._buildError(`'${t}' exports an invalid plugin '${s}' with unknown order '${n}'.`)._printErrorAndExit();break;case"buildStart":case"resolveId":case"load":case"transform":case"shouldInvalidCache":case"moduleParsed":case"buildEnd":n&&"function"!=typeof n&&r?._buildError(`'${t}' exports an invalid plugin '${s}' whose hook '${o}' is not a function.`)._printErrorAndExit();break;default:r?.warn(`'${t}' exports an invalid plugin '${s}' with unknown property: '${o}'.`)}}))}function manualChunks(e,{getModuleInfo:t}){if(e.includes(constants_js_1.NODE_MODULES)||e.includes(constants_js_1.OH_NODE_MODULES))return"commons";const r=t(e);return r&&!r.isEntry?"vendors":void 0}function getCompileInputObject(e){const t={};return Object.entries(e).forEach((([e,r])=>{const s=e.startsWith("../")?`relative/../${e}`:e;t[s]=r})),t}function generateConfig(e,t,r){const s=getMergedConfig(e);(0,load_sdk_functions_js_1.loadSdkFunctions)(s);const o=s.compileMode?.toLowerCase(),n=s.buildMode?.toLowerCase(),a=s.cachePath,i=n===constants_js_1.DEBUG?path_1.default.resolve(__dirname,s.aceModuleBuild):path_1.default.join(a,"releaseAssets",path_1.default.basename(s.aceModuleBuild)),l=getCacheDirectory(e,a);return{perf:e.perf===constants_js_1.AnalyzeMode.VERBOSE,unsupportedChangedFiles:[path_1.default.resolve(e.modulePath,e.packageManagerType===constants_js_1.OHPM?constants_js_1.OH_PACKAGE_JSON5:constants_js_1.PACKAGE_JSON)],generateModuleGraphOnly:o===constants_js_1.ESMODULE,input:getCompileInputObject("true"===e.widgetCompile?load_sdk_functions_js_1.widgetEntryObj:load_sdk_functions_js_1.entryObj),output:[{dir:i,chunkFileNames:"[name].js",format:"cjs",sourcemap:o===constants_js_1.JSBUNDLE&&!e.isPreview,sourcemapPathTransform:(t,r)=>{if(e.buildMode===constants_js_1.RELEASE){const s=loadAceBuildJson(e.aceBuildJson);return path_1.default.resolve(path_1.default.dirname(r),t).replace(s.projectRootPath,"")}return path_1.default.resolve(path_1.default.dirname(r),t)},exports:"named",sanitizeFileName:!1,bundleMode:o===constants_js_1.JSBUNDLE,manualChunks:s.supportChunks?manualChunks:void 0}],shimMissingExports:!0,preserveSymlinks:!1,external:getHarExternal(s),context:"globalThis",treeshake:n===constants_js_1.RELEASE,disableGenerateBundle:o===constants_js_1.ESMODULE,plugins:getPlugins(s,t,r),watch:getWatchConfig(o),watchMode:e.watchMode,enableFileSystemCache:!0,cacheDirectory:l,onwarn(e){"SHIMMED_EXPORT"!==e.code&&console.warn("[33m",e.message,"[39m")},startEvent:e.startEvent,endEvent:e.endEvent}}function getCacheDirectory(e,t){let r=t??"";return"true"===e.watchMode&&(r=path_1.default.resolve(r,e.targetName)),r}function getWatchConfig(e){return{skipWrite:e===constants_js_1.ESMODULE,buildDelay:100}}exports.runArkPack=runArkPack,exports.getResolveModules=getResolveModules,exports.loadAceBuildJson=loadAceBuildJson;var compile_code_snippet_js_2=require("./work-scripts/compile-code-snippet.js");function watch(e,t,r,s,o){return e.watchMode="true",runArkPack(e,t,r,s,o)}function wrapperBuildEnd(e,t){return function(r){const s=getCompilePluginContext(this);try{e.buildEnd.apply(s,[r])}catch(e){throw e.message=`${e.message} ${t.hvigorPluginFile}`,e}}}function wrapperModuleParsed(e,t){return function(r){const s=getCompilePluginContext(this);try{e.moduleParsed.apply(s,[r])}catch(e){throw e.message=`${e.message} ${t.hvigorPluginFile}`,e}}}function wrapperShouldInvalidCache(e,t){return function(r){const s=getCompilePluginContext(this);let o;try{o=e.shouldInvalidCache.apply(s,[r])}catch(e){throw e.message=`${e.message} ${t.hvigorPluginFile}`,e}return o}}function wrapperTransform(e,t){return function(r,s){const o=getCompilePluginContext(this);let n;try{n=e.transform.apply(o,[r,s])}catch(e){throw e.message=`${e.message} ${t.hvigorPluginFile}`,e}return n}}function wrapperLoad(e,t){return function(r){const s=getCompilePluginContext(this);let o;try{o=e.load.apply(s,[r])}catch(e){throw e.message=`${e.message} ${t.hvigorPluginFile}`,e}return o}}function wrapperResolveId(e,t){return function(r,s,o){const n=getCompilePluginContext(this);let a;try{a=e.resolveId.apply(n,[r,s])}catch(e){throw e.message=`${e.message} ${t.hvigorPluginFile}`,e}return a}}function wrapperBuildStart(e,t){return function(r){const s=getCompilePluginContext(this);try{e.buildStart.apply(s)}catch(e){throw e.message=`${e.message} ${t.hvigorPluginFile}`,e}}}function doWrapper(e,t){const r={name:e.name};return e.buildStart&&(r.buildStart=wrapperBuildStart(e,t)),e.resolveId&&(r.resolveId=wrapperResolveId(e,t)),e.load&&(r.load=wrapperLoad(e,t)),e.transform&&(r.transform=wrapperTransform(e,t)),e.shouldInvalidCache&&(r.shouldInvalidCache=wrapperShouldInvalidCache(e,t)),e.moduleParsed&&(r.moduleParsed=wrapperModuleParsed(e,t)),e.buildEnd&&(r.buildEnd=wrapperBuildEnd(e,t)),r}function getCompilePluginContext(e){return{getFileName:t=>e.getFileName(t),getModuleIds:()=>e.getModuleIds(),getModuleInfo:t=>e.getModuleInfo(t),parse:(t,r)=>e.parse(t,r),share:e.share}}function updateEventNames(e){const[t,r]=initUpdateEventNameHandler();return e.forEach((e=>{const s=e.getName(),o=s.lastIndexOf("-");if(t.has(s))t.get(s)(e);else{const t=["beforeBuildEnd","buildEnd","afterBuildEnd","beforeBuild","buildStart","resolveId","load","resolveDynamicImport","shouldTransformCachedModule","transform","moduleParsed"];for(const n of t)if(s.endsWith(n)){const t=r.get(n);t&&t(e,s,o);break}}})),e}function initUpdateEventNameHandler(){const e=new Map;e.set("# BUILD",(e=>e.setName("generate build graph for source files"))),e.set("## initialize",(e=>e.setName("initialize compiler input"))),e.set("## generate module graph",(e=>e.setName("generate module graph"))),e.set("## sort and bind modules",(e=>e.setName("sort and bind modules"))),e.set("## mark included statements",(e=>e.setName("mark included statements")));const t=new Map;return t.set("beforeBuildEnd",((e,t,r)=>e.setName(`${t.substring(0,r)}- execute hook function before build ends`))),t.set("buildEnd",((e,t,r)=>e.setName(`${t.substring(0,r)}- execute hook function when build ends`))),t.set("afterBuildEnd",((e,t,r)=>e.setName(`${t.substring(0,r)}- execute hook function after build ends`))),t.set("beforeBuild",((e,t,r)=>e.setName(`${t.substring(0,r)}- execute hook function before build starts`))),t.set("buildStart",((e,t,r)=>e.setName(`${t.substring(0,r)}- execute hook function when build starts`))),t.set("resolveId",((e,t,r)=>e.setName(`${t.substring(0,r)}- resolve file ID`))),t.set("load",((e,t,r)=>e.setName(`${t.substring(0,r)}- load file content`))),t.set("resolveDynamicImport",((e,t,r)=>e.setName(`${t.substring(0,r)}- resolve dynamic import`))),t.set("shouldTransformCachedModule",((e,t,r)=>e.setName(`${t.substring(0,r)}- decide whether to transform cached module`))),t.set("transform",((e,t,r)=>e.setName(`${t.substring(0,r)}- transform file content`))),t.set("moduleParsed",((e,t,r)=>e.setName(`${t.substring(0,r)}- execute hook function when module parsed`))),[e,t]}Object.defineProperty(exports,"compileCodeSnippet",{enumerable:!0,get:function(){return compile_code_snippet_js_2.compileCodeSnippet}}),exports.watch=watch;