"use strict";var __importDefault=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(exports,"__esModule",{value:!0}),exports.registryWorkerProcessListener=void 0;const cluster_1=__importDefault(require("cluster")),log4js_1=require("log4js"),process_1=__importDefault(require("process")),index_js_1=require("../../boot/index.js"),build_event_js_1=require("../../common/daemon-protocol/build-event.js"),global_data_js_1=require("../../internal/data/global-data.js"),hvigor_log_js_1=require("../../log/hvigor-log.js"),hvigor_daemon_log_js_1=require("../log/hvigor-daemon-log.js"),watch_config_file_js_1=require("./watch-config-file.js"),worker_process_event_id_js_1=require("./worker-process-event-id.js");function addExitHandler(e){let r=!1;const o=(o,t)=>{if(r)return;r=!0;let s=!1;t&&(e.debug(`hvigor worker: Exit with error: ${t}`),t instanceof Error&&t.stack&&e.debug(`hvigor worker: Stack: ${t.stack}`)),setTimeout((()=>{e.debug("hvigor worker: Set process exit timeout in 1000 ms."),e.debug(`hvigor worker: worker process exit. exitCode=${o}`),s||(s=!0,setImmediate((()=>process_1.default.exit(o))))}),1e3)};process_1.default.on("exit",(r=>{e.debug(`hvigor worker: worker process exit (${r}).`),o(r)})),process_1.default.on("SIGHUP",(()=>o(129))),process_1.default.on("SIGINT",(()=>o(130))),process_1.default.on("SIGTERM",(()=>o(143))),process_1.default.on("SIGBREAK",(()=>o(149))),process_1.default.on("uncaughtException",(e=>o(1,e))),process_1.default.on("unhandledRejection",(e=>o(1,e)))}function initWorkerLogger(){var e;const r=null!==(e=process_1.default.env._logLevel)&&void 0!==e?e:log4js_1.levels.INFO;(0,hvigor_daemon_log_js_1.configureDaemon)();const o=hvigor_daemon_log_js_1.HvigorDaemonLogger.getLogger("daemon"),t=log4js_1.levels.getLevel(r);return(0,hvigor_log_js_1.evaluateLogLevel)(t,["daemon"]),o}function onOnline(e,r){e.on("online",(()=>{r.debug(`hvigor worker: worker ${process_1.default.pid} with worker id ${e.id} is online.`)}))}function onDisconnect(e,r){e.on("disconnect",(()=>{r.debug(`hvigor worker: worker ${process_1.default.pid} with worker id ${e.id} is disconnected.`)}))}function onExit(e,r){e.on("exit",((o,t)=>{r.debug(`hvigor worker: worker ${process_1.default.pid} with worker id ${e.id} exit. (${o||t})`)}))}function onError(e,r){process_1.default.on("error",(o=>{r.error(`hvigor worker: worker ${process_1.default.pid} with worker id ${e.id} has an error. Error: ${o}`),o.stack&&r.error(o.stack)}))}function onBuild(e,r){e.on("message",(async e=>{var o,t,s,i;if(e.type===build_event_js_1.BuildEvent.COMMON_BUILD){(0,watch_config_file_js_1.setRunning)(!0);const n=e.content;try{(0,global_data_js_1.initStartData)(n)}catch(e){return r.error(e),void process_1.default.send({type:worker_process_event_id_js_1.WORKER_PROCESS_EVENT_ID.FAILED,content:null!==(t=null!==(o=e.stack)&&void 0!==o?o:e.message)&&void 0!==t?t:e})}(0,hvigor_log_js_1.evaluateLogLevel)(global_data_js_1.startParameters.logLevel,["daemon"]);try{await(0,index_js_1.boot)(e.content)}catch(e){r.error(e),process_1.default.send({type:worker_process_event_id_js_1.WORKER_PROCESS_EVENT_ID.FAILED,content:null!==(i=null!==(s=e.stack)&&void 0!==s?s:e.message)&&void 0!==i?i:e})}}}))}function initWorkerProcessListeners(e){const r=cluster_1.default.worker;onOnline(r,e),onDisconnect(r,e),onExit(r,e),onError(r,e),onBuild(r,e)}function registryWorkerProcessListener(){if(cluster_1.default.isWorker){const e=initWorkerLogger();initWorkerProcessListeners(e),addExitHandler(e)}}exports.registryWorkerProcessListener=registryWorkerProcessListener;