"use strict";var __createBinding=this&&this.__createBinding||(Object.create?function(e,o,t,r){void 0===r&&(r=t);var i=Object.getOwnPropertyDescriptor(o,t);i&&!("get"in i?!o.__esModule:i.writable||i.configurable)||(i={enumerable:!0,get:function(){return o[t]}}),Object.defineProperty(e,r,i)}:function(e,o,t,r){void 0===r&&(r=t),e[r]=o[t]}),__setModuleDefault=this&&this.__setModuleDefault||(Object.create?function(e,o){Object.defineProperty(e,"default",{enumerable:!0,value:o})}:function(e,o){e.default=o}),__importStar=this&&this.__importStar||function(e){if(e&&e.__esModule)return e;var o={};if(null!=e)for(var t in e)"default"!==t&&Object.prototype.hasOwnProperty.call(e,t)&&__createBinding(o,e,t);return __setModuleDefault(o,e),o},__importDefault=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(exports,"__esModule",{value:!0}),exports.startHvigorBuild=exports.parseCommand=void 0;const commander_1=require("commander"),log4js=__importStar(require("log4js")),process_1=__importDefault(require("process")),util_1=__importDefault(require("util")),exit_js_1=require("../../base/boot/hooks/exit.js"),hvigor_daemon_client_log_js_1=require("../../base/daemon/log/hvigor-daemon-client-log.js"),process_info_util_js_1=require("../../base/daemon/util/process-info-util.js"),global_data_js_1=require("../../base/internal/data/global-data.js"),default_configuration_js_1=require("../../base/log/default-configuration.js"),hvigor_log_js_1=require("../../base/log/hvigor-log.js"),std_hook_js_1=require("../util/std-hook.js"),wrapper_const_js_1=require("../wrapper/wrapper-const.js"),cliVersion=wrapper_const_js_1.CUR_HVIGOR_VERSION,_log=hvigor_log_js_1.HvigorLogger.getLogger("hvigor"),hvigorCommandMixin={flagPair(e,o){return this.option(`--${e}`,`Enable ${o}`).option(`--no-${e}`,`Disable ${o}`)},deprecatedOption(e,o,t){return this.option(e,`['${e}' deprecated: use '${o}' instead] ${t}`)}};function parseCommand(){(0,std_hook_js_1.initHook)();let e=[];commander_1.program.version(cliVersion,"-v, --version","Show version of Hvigor.").name("hvigor").usage("[taskNames...] <options...>").option("-e, --error","Set log level to error.").option("-w, --warn","Set log level to warn.").option("-i, --info","Set log level to info.").option("-d, --debug","Set log level to debug.").option("-p, --prop <value>","Define extra properties.",((e,o)=>e.length>wrapper_const_js_1.HVIGOR_CLI_LENGTH?(_log.warn("The length of the parameter field exceeds 512 characters"),o):o.concat([e])),[]).option("--node-home, <string>","Specifies the nodejs location.").option("--hvigor-user-home, <string>","Specifies the hvigor workspace.").option("-m, --mode <string>","Specifies the mode in which the command is currently executed.").option("-s, --sync","Sync the information in plugin for other platform.").deprecatedOption("--enable-build-script-type-check","type-check","Enable the build script hvigorfile.ts type check.").option("--stop-daemon","Shut down current project's daemon process.").option("--watch","Enable watch mode").option("--stop-daemon-all","Shut down all projects' daemon process.").option("--status-daemon","Show all daemon process's status of the project.").flagPair("stacktrace","printing out the stacktrace for all exceptions.").flagPair("type-check","the build script hvigorfile.ts type check.").flagPair("parallel","parallel building mode.").flagPair("incremental","incremental building mode.").flagPair("daemon","building with daemon process.").flagPair("pnpm-frozen-lockfile","lockfile.").flagPair("generate-build-profile","generate BuildProfile.ets files.").flagPair("analyze","building analyze.").option("--verbose-analyze","building analyze in detail.").option("-c, --config <config>","Set properties in the hvigor-config.json5 file. The settings will overwrite those in the file.",((e,o=[])=>o.concat(e))).addHelpText("after","\nExamples:\n  hvigor assembleApp  Do assembleApp task\n").addHelpText("after","copyright 2023").allowUnknownOption(),commander_1.program.arguments("[taskNames...]").action((o=>e=o)),commander_1.program.command("version").action((()=>{_log.info("CLI version:",cliVersion),_log.info("Local version:",cliVersion||"Unknown"),(0,exit_js_1.exit)(0)})).description("Show version of Hvigor."),commander_1.program.command("tasks").action((()=>{e.unshift("tasks")})).description("Show all available tasks of specific modules."),commander_1.program.command("taskTree").action((()=>{e.unshift("taskTree")})).description("Show all available taskTree of specific modules."),commander_1.program.command("prune").action((()=>{e.unshift("prune")})).description("Clean up old hvigor cache files and remove unreferenced packages from store."),commander_1.program.command("collectCoverage").action((()=>{e.unshift("collectCoverage")})).description("Generate coverage statistics reports based on instrumentation dotting data."),commander_1.program.parse(process_1.default.argv);const o={...commander_1.program.opts(),_:e};return(0,global_data_js_1.initStartData)(o),initLogger(),(0,hvigor_log_js_1.evaluateLogLevel)(global_data_js_1.startParameters.logLevel),o}function initDaemonClientLogger(){(0,hvigor_daemon_client_log_js_1.configureDaemonClient)(),(0,hvigor_log_js_1.evaluateLogLevel)(global_data_js_1.startParameters.logLevel)}function initLogger(){log4js.shutdown(),log4js.configure((0,default_configuration_js_1.getConfiguration)())}async function startHvigorBuild(e){if(e.stopDaemon&&(0,process_info_util_js_1.stopDaemons)(!1),e.stopDaemonAll&&(0,process_info_util_js_1.stopDaemons)(!0),e.statusDaemon&&(0,process_info_util_js_1.logDaemonInfo)(),_log.debug(`env: daemon=${global_data_js_1.startParameters.daemon}`),global_data_js_1.startParameters.daemon){initDaemonClientLogger();const{daemonBoot:o}=require("./daemon-client.js");await o(e)}else{process_1.default.execArgv.length>0?_log.debug(`no-daemon, use the parent process.execArgv ${process_1.default.execArgv}`):_log.debug("no-daemon, use the default node options");const{boot:o}=require("../../base/boot/index.js");await o(e)}_log.debug(`hvigor start cli arguments:${util_1.default.inspect(e)}`)}Object.assign(commander_1.Command.prototype,hvigorCommandMixin),exports.parseCommand=parseCommand,exports.startHvigorBuild=startHvigorBuild;